/****************************************************************************
 * FSopenc.h     FlagShip include file for variable access in inline C      *
 *               and Open C System                                          *
 *                                                                          *
 * Release 4.4x from 02/1998                                                *
 *--------------------------------------------------------------------------*
 * (c) 1998 multisoft Datentechnik GmbH, Munich. All rights reserved.       *
 ****************************************************************************/

/* the function prototypes are defined in FlagShip.h */

#ifndef   __FGS_OPENC__
#  define __FGS_OPENC__

#ifndef __FGS_FLAGSHIP__
#  include "FlagShip.h"
#endif

/* ----------------------- Prototypes ------------------------------------- */

extern FSvar    * dget_arr         FGS_ANSI((FSvar *, FSint));
extern FSchar   * fgs2Lower        FGS_ANSI((FSchar *));
extern FSchar   * fgs2Upper        FGS_ANSI((FSchar *));
extern FSvar    * fgsBlockEval     FGS_ANSI((FSvar *));
extern FSint      fgsEmptyVar      FGS_ANSI((FSvar *));
extern FSvar    * fgsGetObj        FGS_ANSI((FSvar *, FSint));
extern FSvar    * set_ivar         FGS_ANSI((FSvar *, FSvoid *));
extern FSint      fgsTrueBlockEval FGS_ANSI((FSvar *));
extern FSvar    * (*fgsGetMethod   FGS_ANSI((FSvar *, FSchar *, FSint)))();
extern FSdouble   fgsNumVar        FGS_ANSI((FSvar *));
extern FSint      fgsIntVar        FGS_ANSI((FSvar *));
extern FSvoid   * fgs_malloc       FGS_ANSI((FSulong, FSchar *, FSint,
                                             FSint,   FSchar *, FSint));
extern FSvoid     fgs_free         FGS_ANSI((FSvoid *, FSchar *, FSint));
extern FSvoid   * fgs_realloc      FGS_ANSI((FSvoid *, FSulong, FSchar *,
                                             FSint, FSint, FSchar *, FSint));
extern FSchar   * fgsAddExtension  FGS_ANSI((FSchar *, FSchar *,
                                             FSchar *, FSint));
extern FSint      fgsAnnounceAlias FGS_ANSI((FSvar *, FSchar *, FSchar *));
extern FSvar    * fgsAnnounceField FGS_ANSI((FSchar *, FSint, FSchar, FSint,
                                             FSint, FSint, FSvoidptr));
extern FSvar    * fgsAttachVar     FGS_ANSI((FSvar **, FSvar *));
extern FSvar    * fgsDetachVar     FGS_ANSI((FSvar **));
extern FSint      fgsRetireAlias   FGS_ANSI((FSvar *));
extern FSvoid     fgsRetireField   FGS_ANSI((FSvar *, FSchar *));


/* ----------------------- Access/Method/Objects -------------------------- */
/* Naming convention .prg vs .c:                                            */
/* FlagShip .prg :               Open-C:                                    */
/*    LOCAL XyzVar               _fgslvar_xyzvar                            */
/*    LOCAL XyzInt AS INT        xyzint                                     */
/*    XyzFun()                   _bb_xyzfun                            old  */
/*    XyzFun() AS USUAL          _bb_xyzfun                            new  */
/*    XyzFun() AS INT            _fsi_xyzfun                                */
/*    METHOD XyzMeth CLASS Xobj  _bb_xobj_xyzmeth_me                        */
/*    ACCESS XyzMeth CLASS Xobj  _bb_xobj_xyzmeth_ac                        */
/*    ASSIGN XyzMeth CLASS Xobj  _bb_xobj_xyzmeth_as                        */

/* -----Declare the Method (function header) and Prototyping--------------- */

#ifdef _FGS_CCNAME_CONV2
#  define OBJ_DECL_METH(clas,name)                                     \
          FSvar * _bb_/**/clas/**/_/**/name/**/_me(argc, argv)         \
          int argc;                                                    \
          FSvar * argv[];
#  define OBJ_DECL_METHACCESS(clas,name)                               \
          FSvar * _bb_/**/clas/**/_/**/name/**/_ac(ovSelf)             \
          FSvar *ovSelf;
#  define OBJ_DECL_METHASSIGN(clas,name)                               \
          FSvar * _bb_/**/clas/**/_/**/name/**/_as(ovSelf, assVar)     \
          FSvar *ovSelf, *assVar;

#  define OBJ_PROT_METH(clas,name)                                     \
          FSvar * _bb_/**/clas/**/_/**/name/**/_me FGS_ANSI((int,FSvar *[]))
#  define OBJ_PROT_METHACCESS(clas,name)                               \
          FSvar * _bb_/**/clas/**/_/**/name/**/_ac FGS_ANSI((FSvar *))
#  define OBJ_PROT_METHASSIGN(clas,name)                               \
          FSvar * _bb_/**/clas/**/_/**/name/**/_as FGS_ANSI((FSvar *, FSvar *))

#else
#  define OBJ_DECL_METH(clas,name)                                     \
          FSvar * _bb_##clas##_##name##_me(argc, argv)                 \
          int argc;                                                    \
          FSvar * argv[];
#  define OBJ_DECL_METHACCESS(clas,name)                               \
          FSvar * _bb_##clas##_##name##_ac(ovSelf)                     \
          FSvar *ovSelf;
#  define OBJ_DECL_METHASSIGN(clas,name)                               \
          FSvar * _bb_##clas##_##name##_as(ovSelf, assVar)             \
          FSvar *ovSelf, *assVar;

#  define OBJ_PROT_METH(clas,name)                                     \
          FSvar * _bb_##clas##_##name##_me FGS_ANSI((int,FSvar *[]))
#  define OBJ_PROT_METHACCESS(clas,name)                               \
          FSvar * _bb_##clas##_##name##_ac FGS_ANSI((FSvar *))
#  define OBJ_PROT_METHASSIGN(clas,name)                               \
          FSvar * _bb_##clas##_##name##_as FGS_ANSI((FSvar *, FSvar *))
#endif

/* -----Access Method Names------------------------------------------------ */

#ifdef _FGS_CCNAME_CONV2
#  define OBJ_METHNAME(clas,name)       _bb_/**/clas/**/_/**/name/**/_me
#  define OBJ_METHNAMEACC(clas,name)    _bb_/**/clas/**/_/**/name/**/_ac
#  define OBJ_METHNAMEASS(clas,name)    _bb_/**/clas/**/_/**/name/**/_as
#else
#  define OBJ_METHNAME(clas,name)       _bb_##clas##_##name##_me
#  define OBJ_METHNAMEACC(clas,name)    _bb_##clas##_##name##_ac
#  define OBJ_METHNAMEASS(clas,name)    _bb_##clas##_##name##_as
#endif

/* --------------------- execute methods from any object -------------------*/

#define OBJ_METHEXEC(nam,methno,pcnt,pars)                                   \
                                        fgsDoMethod(nam, methno, 0, pcnt, pars)
#define OBJ_ACCEXEC(obj,nam,methno)     fgsDoInstance(obj, nam, methno, 0, 0)
#define OBJ_ASSEXEC(obj,nam,methno,val) fgsDoInstance(obj, nam, methno, 0, val)

/* -----Function declarator, use FSFUNCTION(myudf)------------------------- */

#ifndef FSudfname
#ifdef _FGS_CCNAME_CONV2

#  define fsFnNAME(name)         _bb_/**/name

#  define fsFnLOCATOR(name)                            \
      extern FSvar * fsFnNAME(name)();                 \
      static struct fsuFuncLocate _sfl_/**/name =      \
          { "FSfntab", "name", fsFnNAME(name) }
#else

#  define fsFnNAME(name)         _bb_##name

#  define fsFnLOCATOR(name)                           \
      extern FSvar * fsFnNAME(name)();                \
      static struct fsuFuncLocate _sfl_##name =       \
          { "FSfntab", #name, fsFnNAME(name) }
#endif

#define FSudfname(name)                     \
    fsFnLOCATOR(name);                      \
    FSvar * fsFnNAME(name)(argc, argv)      \
    int argc;                               \
    FSvar * argv[];

#define FSstaticudf(name)                   \
    FSvar * fsFnNAME(name)(argc, argv)      \
    int argc;                               \
    FSvar * argv[];

#define fsCodeBlock(name)           \
    FSvar *                         \
    name (argc, argv, argv2)        \
    int argc;                       \
    FSvar * argv[];                 \
    FSvar * argv2[];

#define fsFnPROTOT(name)                            \
    extern FSvar *                                  \
    fsFnNAME(name) FGS_ANSI((int, FSvar *[]))

#define FSudfCALL(name) fsFnNAME(name)

#endif

#define UDF_DECL(name)  FSudfname(name)
#define UDF_EXEC(name)  fsFnNAME(name)
#define UDF_PROT(name)  fsFnPROTOT(name)

/*------------------------- Memory allocation --- may be subject to change -*/
#define Mmalloc(p1, p2, p3, p4)   fgs_malloc(p1,p2,p3,p4,__FILE__,__LINE__)
#define Mrealloc(p1,p2,p3,p4,p5)  fgs_realloc(p1,p2,p3,p4,p5,__FILE__,__LINE__)
#define Mfree(p1)                 fgs_free(p1,__FILE__,__LINE__)

/* ----------------------- Create FlagShip variables ---------------------- */

#define VAR_NEW                      cre_tmpvar()
#define VAR_NEW_ARGS(var,x)          {int i; for(i=0;i<x;i++) var[i]=VAR_NEW;}
#define VAR_NEW_COPY(v2)             cpy_var(VAR_NEW,v2)
#define VAR_NEW_ARRAY(var,dim)       (var=cre_arr(VAR_NEW,(int)(dim), 0))
#define VAR_CRE_ARRAY(var,dim)       (cre_arr(var,(int)(dim), 0))
#define VAR_NEW_STATIC               mak_var('N', 'U')
#define VAR_NEW_STATIC_COPY(v2)      cpy_var(VAR_NEW_STATIC,v2)
#define VAR_NEW_STATIC_ARRAY(var,dim) (var=cre_arr(VAR_NEW_STATIC, \
                                                   (int)(dim), 0))
#define VAR_DELETE                   del_tmpvars(old_fn_stack->tmv_now)
#define VAR_DEL_ONEVAR(var)          del_var(var)
#define VAR_DEL_MARK()               tmpvar_cnt
#define VAR_DEL_SINCE_MARK(ivar)     del_tmpvars(ivar)

/* ----------------------- Get variable name ------------------------------ */
/* NOTE: These defines to resolve variable names make use of the ## C pre-  */
/*       processor directive. It is is not supported by all C preprocessors.*/
/*       On some defined Systems, we resolve this using the comment         */
/*       construct as shown below.                                          */

#ifdef _FGS_CCNAME_CONV2
#  define VAR_NAME_LOCAL(xx)     _fgslvar_/**/xx
#  define VAR_NAME_LOCPAR(xx)    _fgspvar_/**/xx
#  define VAR_NAME_STATIC(xx)    _fgssvar_/**/xx
#  define VAR_NAME_MEMVAR(xx)    mv_names[_bbvar_/**/xx].v
#  define VAR_NAME_FIELD(xx)     fgsGetField(_bbvar_/**/xx)
#else
#  define VAR_NAME_LOCAL(xx)     _fgslvar_##xx
#  define VAR_NAME_LOCPAR(xx)    _fgspvar_##xx
#  define VAR_NAME_STATIC(xx)    _fgssvar_##xx
#  define VAR_NAME_MEMVAR(xx)    mv_names[_bbvar_##xx].v
#  define VAR_NAME_FIELD(xx)     fgsGetField(_bbvar_##xx)
#endif

/* ----------------------- Determine the variable type -------------------- */

#define VAR_ISTYPE(var)        ((var)->type)
#define VAR_ISMODE(var)        ((var)->mode)
#define VAR_ISLEN(var)         ((var)->len)
#define VAR_ISDECI(var)        ((var)->dec)
#define VAR_ISFLDPOS(var)      ((var)->fldidx)
#define VAR_ISFLDWA(var)       (((var)->fov.w_area)->iNumber)
#define VAR_ISDIM(var)         (((var)->val.cb.buff)->component_count)

#define IS_VAR_ARR(var)        (VAR_ISTYPE(var)=='A')
#define IS_VAR_BLK(var)        (toupper(VAR_ISTYPE(var))=='B')
#define IS_VAR_BLOCK(var)      IS_VAR_BLK(var)
#define IS_VAR_CHR(var)        strchr("CM", VAR_ISTYPE(var))
#define IS_VAR_DATE(var)       (VAR_ISTYPE(var)=='D')
#define IS_VAR_FIELD(var)      (toupper(VAR_ISMODE(var))=='F')
#define IS_VAR_FNUM(var)       strchr("NF", VAR_ISTYPE(var))
#define IS_VAR_FP(var)         (IS_VAR_FNUM(var))
#define IS_VAR_INT(var)        (VAR_ISTYPE(var)=='I')
#define IS_VAR_LOG(var)        (VAR_ISTYPE(var)=='L')
#define IS_VAR_NIL(var)        (VAR_ISTYPE(var)=='U')
#define IS_VAR_NUM(var)        strchr("INF", VAR_ISTYPE(var))
#define IS_VAR_OBJ(var)        (VAR_ISTYPE(var)=='O')
#define IS_VAR_SCR(var)        (VAR_ISTYPE(var)=='S')
#define IS_VAR_SPECIAL(var)    (VAR_ISTYPE(var)=='?')
#define IS_VAR_XLOG(var)       strchr("LINF", VAR_ISTYPE(var))
#define IS_VAR_XNUM(var)       strchr("INFL", VAR_ISTYPE(var))

#define IS_VAR_EMPTY(var)      (fgsEmptyVar(var) > 0)
#define IS_VAR_TRUE(var)       (IS_VAR_LOG(var) && fgsLogVar(var))
#define IS_VAR_TRUE_BLK(var)   fgsTrueBlockEval(var)
#define IS_VAR_FALSE(var)      (IS_VAR_LOG(var) && !fgsLogVar(var))
#define IS_VAR_STD(var)        strchr("CDNLM",VAR_ISTYPE(var))
#define IS_VAR_BYREF(var)      strchr("SsPpMmCcNnLlVvF",VAR_ISMODE(var))
#define IS_VAR_EVAL_TRUE(var)  IS_VAR_TRUE_BLK(var)

#define IS_VAR_EQ(var1, var2)  VAR_LOG(u_equ_u (var1, var2))
#define IS_VAR_EE(var1, var2)  VAR_LOG(u_eequ_u(var1, var2))
#define IS_VAR_NE(var1, var2)  VAR_LOG(u_neq_u (var1, var2))
#define IS_VAR_GT(var1, var2)  VAR_LOG(u_gt_u  (var1, var2))
#define IS_VAR_GE(var1, var2)  VAR_LOG(u_geq_u (var1, var2))
#define IS_VAR_LT(var1, var2)  VAR_LOG(u_lt_u  (var1, var2))
#define IS_VAR_LE(var1, var2)  VAR_LOG(u_leq_u (var1, var2))

/*--------------------- access to function arguments -----------------------*/

#define ISCHRARG(n)  ((argc>n) && argv[n] && IS_VAR_CHR(argv[n]))
#define ISINTARG(n)  ((argc>n) && argv[n] && IS_VAR_INT(argv[n]))
#define ISNUMARG(n)  ((argc>n) && argv[n] && IS_VAR_NUM(argv[n]))
#define ISXNUMARG(n) ((argc>n) && argv[n] && IS_VAR_XNUM(argv[n]))
#define ISLOGARG(n)  ((argc>n) && argv[n] && IS_VAR_LOG(argv[n]))
#define ISXLOGARG(n) ((argc>n) && argv[n] && IS_VAR_XLOG(argv[n]))
#define ISDATARG(n)  ((argc>n) && argv[n] && IS_VAR_DAT(argv[n]))
#define ISARRARG(n)  ((argc>n) && argv[n] && IS_VAR_ARR(argv[n]))
#define ISSCRARG(n)  ((argc>n) && argv[n] && IS_VAR_SCR(argv[n]))
#define ISBLKARG(n)  ((argc>n) && argv[n] && IS_VAR_BLK(argv[n]))
#define ISNILARG(n)  ((argc>n) && argv[n] && IS_VAR_NIL(argv[n]) || (argc<=n))
#define ISOBJARG(n)  ((argc>n) && argv[n] && IS_VAR_OBJ(argv[n]))

#define ISTRUARG(n)  ((argc>n) && argv[n] && IS_VAR_TRUE(argv[n]))
#define ISFLSARG(n)  ((argc>n) && argv[n] && IS_VAR_FALSE(argv[n]))

/* ----------------------- Acces to variable contents --------------------- */

#define VAR_ARRELEM(var,elem)   (dget_arr(var,(int)(elem)))
#define VAR_BLOCK(var)          ((var)->val.cb.block)
#define VAR_BLOCK_COMPILE(cvar) (fgsMakeCB(IS_VAR_CHR(cvar) ? \
                                 VAR_CHR(cvar) : (FSuchar *) ".F."))
#define VAR_BLOCK_EVAL(var)     (fgsBlockEval(var))
#define VAR_DATE(var)           ((var)->val.date)
#define VAR_CHR(var)            ((var)->val.chr)
#define VAR_INT(var)            ((var)->val.inum)
#define VAR_LOG(var)            ((var)->val.inum)
#define VAR_NUM(var)            ((var)->val.fnum)
#define VAR_OBJINST(obj,name)   (OBJ_ACCEXEC(obj,name,-1))
#define VAR_OBJ(var,elem)       (fgsGetObj(var,(int)(elem)))
#define VAR_SCR(var)            ((var)->val.scr)
#define VAR_SPECIAL(var)        ((var)->val.intern_data)

#define VAR_INTNUM(var)        fgsIntVar(var)
#define VAR_FPNUM(var)         fgsNumVar(var)
/* ----------------------- Assign value to variables ---------------------- */

#define SET_VAR_COPY(v1,v2)      cpy_var(v1,v2)
#define SET_VAR_CHR(var,s)       set_Cvar(var,s,-1)
#define SET_VAR_CHRLEN(var,s,l)  set_Cvar(var,s,l)
#define SET_VAR_DATE(var,l)      set_dvar(var,l)
#define SET_VAR_NIL(var)         cpy_var (var,NIL_VAR)
#define SET_VAR_INT(var,n)       set_Ivar(var,n)
#define SET_VAR_NUM(var,n)       set_nvar(var,n,-1)
#define SET_VAR_NUMDECI(var,n,d) set_nvar(var,n,d)
#define SET_VAR_LOG(var,i)       set_lvar(var,i)
#define SET_VAR_OBJINST(obj,name,val) (OBJ_ASSEXEC(obj,name,-1,val)
#define SET_VAR_SCR(var, win)    set_Svar(var,win)
#define SET_VAR_BLOCK(var,name)  set_bvar(var,name,0,0)
#define SET_VAR_SPECIAL(var,ptr) set_ivar(var,ptr)
#define SET_VAR_UPPER(var)       fgs2Upper((FSchar *) VAR_CHR(var))
#define SET_VAR_LOWER(var)       fgs2Lower((FSchar *) VAR_CHR(var))
#define SET_VAR_ADD(var1, var2)  u_add_u(var1, var2, 0)
#define SET_VAR_MACRO(var, src)  cpy_var(var, fgsVMxV(src, 3))

/* ----------------------- Other definitions ------------------------------ */

#define FS_QUIT_COMMAND        fsFnNAME(__quit)(0, 0)
#define COMPILE_BLOCK(cvar)    (VAR_BLOCK_COMPILE(cvar))
#define VAR_EVAL_BLOCK(bVar)   (VAR_BLOCK_EVAL(bVar))

/* ----------------------- Class definitions ------------------------------ */


/* The old FS4.3 definitions for the error object */

#define ERROBJ_ARGS        ErrorArgsInstance
#define ERROBJ_CANDEFAULT  ErrorCandefaultInstance
#define ERROBJ_CANRETRY    ErrorCanretryInstance
#define ERROBJ_CANSUBSTIT  ErrorCansubstitInstance
#define ERROBJ_CARGO       ErrorCargoInstance
#define ERROBJ_DESCRIPTIO  ErrorDescriptioInstance
#define ERROBJ_FILENAME    ErrorFilenameInstance
#define ERROBJ_GENCODE     ErrorGencodeInstance
#define ERROBJ_OPERATION   ErrorOperationInstance
#define ERROBJ_OSCODE      ErrorOscodeInstance
#define ERROBJ_SEVERITY    ErrorSeverityInstance
#define ERROBJ_SUBCODE     ErrorSubcodeInstance
#define ERROBJ_SUBSYSTEM   ErrorSubsystemInstance
#define ERROBJ_TRIES       ErrorTriesInstance

# define ErrorArgInstance         2
# define ErrorArgnumInstance      3
# define ErrorArgsInstance        4
# define ErrorArgtypereqInstance  5
# define ErrorCallfuncsyInstance  6
# define ErrorCandefaultInstance  7
# define ErrorCanretryInstance    8
# define ErrorCansubstitInstance  9
# define ErrorCargoInstance      10
# define ErrorChoiceInstance     11
# define ErrorDescriptioInstance 12
# define ErrorFilehandleInstance 13
# define ErrorFilenameInstance   14
# define ErrorFuncptrInstance    15
# define ErrorFuncsymInstance    16
# define ErrorGencodeInstance    17
# define ErrorMaxsizeInstance    18
# define ErrorMethodselfInstance 19
# define ErrorOperationInstance  20
# define ErrorOscodeInstance     21
# define ErrorSeverityInstance   22
# define ErrorSubcodeInstance    23
# define ErrorSubcodetexInstance 24
# define ErrorSubstituteInstance 25
# define ErrorSubsystemInstance  26
# define ErrorTriesInstance      27

#endif     /* ifndef __FGS_OPENC__ */
/* EOF FSopenc.h */

