/****************************************************************************
 * Function tbrowsedb       Generates a tbrowse object according to the dbf *
 * In : p1 (N) Upper Border                                                 *
 *      p2 (N) Left  Border                                                 *
 *      p3 (N) Lower Border                                                 *
 *      p4 (N) Right Border                                                 *
 * Out: fn (Browse-Obj) on success, NIL_VAR else                            *
 *--------------------------------------------------------------------------*
 * (c) 1998 multisoft Datentechnik GmbH, Germany.                           *
 ****************************************************************************/

#include "tbrclass.fh"

function tbrowsedb(top, left, bottom, right)
local ii, fieldc, col


* fieldc = fcount()
* if fieldc < 1
*    return(NIL)
* endif

LOCAL obj := tbrowsenew(top, left, bottom, right) AS Tbrowse
obj:gobottomblock := { || dbgobottom()}
obj:gotopblock    := { || dbgotop()}
obj:skipblock     := { |xx| __tbroskip(xx)}

* for ii = 1 to fieldc
*   col := tbcolumnnew(fieldname(ii), fieldblock(fieldname(ii)))
*   obj:addcolumn(col)
* next

return(obj)



*****************************************************************************
* Function __tbroskip                 The Skipblock of tbrowsenew() objects *
*                                     Actually the same as dbskip, but will *
*                                     not position onto eof.                *
* In : p1 (N) Number of Records to skip                                     *
* Out: fn (N) Number of Records really skipped                              *
*****************************************************************************
function __tbroskip(toskip)
local xx := dbskip(toskip)
if !eof()
    return (xx)
else
    skip -1
    return(xx - 1)
endif
* EOF browsedb.prg *
