/****************************************************************************
 * CURSINIT.PRG   FlagShip 4.x curses initialization                        *
 *                                                                          *
 * FlagShip     : compile local  FlagShip cursinit.prg -m -na -c            *
 *                link with appl FlagShip myprog*.prg cursinit.o ...        *
 *--------------------------------------------------------------------------*
 * Copyright(c) 1998 by multisoft GmbH.                                     *
 ****************************************************************************/

FUNCTION cursesinit()      


// If the FlagShip application is to be run in background, you may comment
// out the "CALL fgsInitCurses". This will completely disable the usage
// of any screen oriented input/output, only flat texts and qout() is
// supported.

// If input via standard FlagShip keyboard input commands (e.g. InKey())
// is desired while the process is running in background, you should 
// remove the asterisk before the "CALL fgsIoctl2"

// WARNING: if the keyboard input is not correctly initialized, using the 
// InKey() function for time-out purposes is NOT POSSIBLE

// WARNING: if "CALL fgsTakeOriginalTermio" is commented out, the terminal
// may stay in an unusable state after leaving the FlagShip application

CALL fgsTakeOriginalTermio // This ensures that your terminal is reset
                           // to its initial state before leaving the
                           // FlagShip application.  This
                           // involves C ioctl() calls. On some systems
                           // (e.g. SUN OS 4.1.x) this "stops" the process
                           // if attempted to be run in background.
                           
CALL fgsInitCurses         // This executes a FULL initialization of curses
                           // and keyboard input handling routines. On some
                           // systems (e.g. LINUX) this prevents the ability
                           // to redirect "standard output" to a file

* CALL fgsIoctl2           // This executes the neccessary initialization
                           // to handle keyboard input correctly in case 
                           // curses were not initialized. This
                           // involves C ioctl() calls. On some systems
                           // (e.g. SUN OS 4.1.x) this "stops" the process
                           // if attempted to be run in background.

CALL fgsSetSpoolOn         // This allows FlagShip to create a default
                           // printer spooler file in the current or the
                           // $FSOUTPUT directory

RETURN
/*** eof ***/

