/****************************************************************************
 * RDDSYS.PRG init procedure to invoke standard FlagShip RDD                *
 *            called automatically at program start                         *
 *                                                                          *
 * Compile :  FlagShip rddsys.prg -m -na -c                                 *
 * Link    :  FlagShip myappl*.prg rddsys.o                                 *
 *--------------------------------------------------------------------------*
 * Copyright (C) 1998 multisoft Datentechnik GmbH                           *
 ****************************************************************************/

STATIC aRddList := {}

ANNOUNCE RDDSYS

// announce the default DbfIdx RDD driver
//
INIT PROCEDURE RddInit
   REQUEST DBFIDXNEW              // force to link default driver
   AnnNewRdd ("DbfIdx")           // announce it for RddList()
   RddSetDefault ("DBFIDX")       // set default RDD driver
RETURN

// all user defined <myrdd> drivers (see e.g. smallrdd.prg) should include:
//
** INIT procedure _<myrdd>
**    REQUEST <myrdd>NEW
**    AnnNewRdd ("<myrdd>")
** RETURN

// this function is called from the INIT procedure of any RDD
//
FUNCTION AnnNewRDD (cName)
   LOCAL found := .F.
   cName := left(upper(cName), 10)
   if len(aRddList) > 0
	  found := ascan(aRddList, cName) > 0 
   endif
   if !found .and. !empty(cName)
	  aadd (aRddList, cName)
   endif
RETURN NIL

// standard FlagShip function RddList()
//
FUNCTION RddList ()
RETURN aRddList

* EOF *
