****************************************************************************
* Rev. 4.3                                                                 *
* Compile: FlagShip repoedit.prg -m -na -c [-nl -nL -nd]                   *
* Link   : FlagShip myprog*.prg repoedit.o [<your switches>]               *
*--------------------------------------------------------------------------*
* Copyright 1998 (c) multisoft GmbH, Germany                               *
*--------------------------------------------------------------------------*
*                                                                          *
*  Syntax: REPORT EDIT <file>|(<file>) [MESSAGES aMsg] [COLOR aColor]      *
*                                                                          *
*  #command REPORT EDIT <(cFile)> [MESSAGES <aMsg>] [COLOR <aCol>] ;       *
*        => __RepoEdit (<(cFile)>, <aMsg>, <aCol>)                         *
*                                                                          *
****************************************************************************

#ifdef FlagShip
#  include "inkey.fh"
** #define FIELDINFO_DEFINED      // FieldInfo() may be included in next FS
#else
#  include "inkey.ch"
#  define LOCAL_INT LOCAL
#endif
#include "report.fh"

// #define GERMAN

#define MAX_EXPR_STR 1440         // may NOT be expanded for .frm structure
#define MAX_FIELD_NO 24           // may NOT be expanded for .frm structure
#define MAX_FLD_TEXT 80           // may be expanded
#define F2_WIDE      23           // may be expanded
#define F3_WIDE      18           // may be expanded

#define REP_FLD_TYPE 6            // do not change
#define REP_FLD_PICT 7            // do not change
#define REP_FLD_SIZE 7            // do not change

// ----------------- global static -------------------------
STATIC text, window := 0
STATIC defcolors :={{"W+/B,N/W",         "W+/N,N/W" }, ;  // 1:std.output
                    {"GR+/B,N/W",        "W/N,N/W"  }, ;  // 2:active window
                    {"BG+/B,N/W",        "W/N,N/W"  }, ;  // 3:messages
                    {"W/B,W/B"  ,        "W/N,W/N"  }, ;  // 4:dbf fields
                    {"G+/N,BG+/N,,,GR+/N","N/W,N/W,,,U"},; // 5:help
                    {"W/B,W+/B",         "W/N,W+/N" }, ;  // 6:choice in F7
                    {"GR+/B,GR+/B",      "W+/N,W+/N"}, ;  // 7:display
                    {"W+/G,W+/B",        "W+/N,W+/N"}, ;  // 8:alert
                    {"R+/B",             "U/N"      }  }  // 9:red
STATIC colors                                       // colors [len(defColors)]
STATIC f5f6_flag := .F.
STATIC k_keys := {K_F1, K_F2, K_F3, K_F4, K_F5, ;
                  K_F6, K_F7, K_F8, K_F9, K_F10, ;
                  K_PGUP, K_PGDN, K_ESC }

STATIC modify, size_elem := 1, lastchoice := 1
STATIC dbfname := "", glfilename := ""
STATIC field_no := 0
STATIC row_f2 := 3,  high_f2 := 8, ;
       row_f4 := 13, high_f4 := 6, ;
       row_f7 := 21, high_f7 := 2
STATIC row_msg, msg_text := ""
STATIC nextwin := K_F2, windend := .T., saved := .F., msg_txt := ""
STATIC currfld := 1, get_updated := .F.

STATIC infield[REP_FLD_SIZE]            // field entry data
STATIC header[4], ;                     // each 4 lines for gener.header
       grphead[4], subhead[4]           // group and subheader text
STATIC fields[MAX_FIELD_NO]             // nested array contain. ea infield[]
STATIC data[17], ;                      // stored data[REP_xxx] in .frm,
       save[17], ;                      //   see repoload()
       display[20]                      // holds data displayed by F7

* +-------------------------------------------------------------------------+
* | MAIN ENTRY using the command REPORT EDIT <filename>                     |
* |                                                                         |
* | [filename]  = .frm file may include path. If not given: prompt          |
* | [aMessages] = Array overlaying deftxt[]                                 |
* | [aColors]   = Array overlaying colors[]                                 |
* |                                                                         |
* | return = filename if successful                                         |
* |        = "" if error occured                                            |
* +-------------------------------------------------------------------------+
FUNCTION __REPOEDIT (filename, aMessages, aColors)
LOCAL ok := .T., ii
LOCAL oldselect := SELECT(), oldcolor, colset
LOCAL screen
LOCAL fukeys := ARRAY (LEN(k_keys)), locarr, autocreate := .F.
LOCAL getlist := {}

#ifdef GERMAN
*------------------ german (or other) output ------------------------------
STATIC deftxt := ;
  {" --- specify yourself according to the english version ---", ; // [1...61]
   " --- or use aMessages[] parameter --- "}
#else
*------------------ english (default) output ------------------------------
STATIC deftxt := ;
 {"F2:page F3:column F4:group F5:fields F7:display F10:save ESC:quit", ;               //  1
  "Page header  line 1  :", ;                                                          //  2
  "             line 2  :", ;                                                          //  3
  "             line 3  :", ;                                                          //  4
  "             line 4  :", ;                                                          //  5
  "Page   wide/high     :     chars         lines", ;                                  //  6
  "Margin left/right    :     chars         chars", ;                                  //  7
  "Double spacing/plain :", ;                                                          //  8
  "Eject  begin/end     :", ;                                                          //  9
  "Group key (express.) :", ;                                                          // 10
  "      header text #1 :", ;                                                          // 11
  "                  #2 :", ;                                                          // 12
  "                  #3 :", ;                                                          // 13
  "                  #4 :", ;                                                          // 14
  "      Summary/Eject  :", ;                                                          // 15
  "Subgroup key (expr.) :", ;                                                          // 16
  "", ;                                                                                // 17
  "Add/Replace/Delete/Ins:", ;                                                         // 18
  "  Expr:", ;                                                                         // 19
  "  Head:", ;                                                                         // 20
  "    #2:", ;                                                                         // 21
  "    #3:", ;                                                                         // 22
  "    #4:", ;                                                                         // 23
  "  Wide:          Deci:", ;                                                          // 24
  " Total:", ;                                                                         // 25
  "(F2) enter report page data. CursUp/CursDn: move  ENTER: confirm   F1:help", ;      // 26
  "(F4) enter group and sub-group data.  CursUp/CursDn: move   ENTER: confirm", ;      // 27
  "(F3) specify report columns.   PgUp/PgDn:next   F7:display  ENTER:confirm", ;       // 28
  "(F5) PgUp/PgDn, CursUp/CursDn:move, scroll  F6:next .dbf  ENTER: overtake", ;       // 29
  "(F7) CursLeft/CursRight: scroll window left/right" , ;                              // 30
  "F6:next dbf", ;                                                                     // 31
  "<>", ;                                                                              // 32
  "Enter report file name", ;                                                          // 33
  "Check the correct entry: TYPE() not character, numeric, date or logical", ;         // 34
  "No REPORT group data specified. Use F3 to specify, ESC to quit.", ;                 // 35
  "At least 24 lines required, available are", ;                                       // 36
  "field " , ;                                                                         // 37
  "File not available", ;                                                              // 38
  "Do not exit", ;                                                                     // 39
  "Create", ;                                                                          // 40
  "Exit" , ;                                                                           // 41
  "Invalid Report file" , ;                                                            // 42
  "Report data not saved yet by F10 key", ;                                            // 43
  "Exit, do not save", ;                                                               // 44
  "Terminate REPORT EDIT", ;                                                           // 45
  "no", ;                                                                              // 46
  "yes", ;                                                                             // 47
  "Maximal expression length in .frm is " , ;                                          // 48
  "Current expression length is " , ;                                                  // 49
  "Minimize the expression strings" , ;                                                // 50
  "Expression must be specified" , ;                                                   // 51
  "Columns not specified, use F3" , ;                                                  // 52
  "Field" , ;                                                                          // 53
  "The .frm structure supports 24 columns only" , ;                                    // 54
  " column " , ;                                                                       // 55
  "ESC,F1..10=Back to window F" , ;                                                    // 56
  "Retry" , ;                                                                          // 57
  "Press FN key or ESC" , ;                                                            // 58
  "AutoCreate" , ;                                                                     // 59
  "Column definition exceeds report page width.;Check by F7, correct the page;width to at least " , ; // 60
  "Report data saved to"  }                                                               // 61

#endif

*-----------------------------------------------------------------------------

screen   := SAVESCREEN (0,0, MAXROW(),MAXCOL())    // save user screen
fukeys   := SavRestFN  ("")                        // save user SET KEYs
oldcolor := SETCOLOR()                             // save user colors

if VALTYPE(aMessages) == "A" .and. LEN(aMessages) >= LEN(deftxt)
   text = aclone(aMessages)
else
   text = deftxt
endif

data := {NIL, NIL, NIL, NIL, NIL, 80, 65, 0, 0, 0,;
         .F., .F., .T., .F., .T., .F., {} }

row_msg    := MAXROW()
if row_msg < 23
   @ 10,10 say text[36] + str(row_msg+1,3)
   wait
   return ""
end

if valtype(aColors) == "A" .and. len(aColors) >= len(defColors)
   colors := aclone (aColors)
else
   colset := if (ISCOLOR(), 1, 2)
   colors := array(len(defColors))
   aeval (defColors, {|x,y| colors[y] := x[colset]})
endif

* +--------------------------------+
* | calculate box size             |
* +--------------------------------+
if row_msg < 24
   high_f2 -= 24 - row_msg
   row_f4  := row_f2 + high_f2 + 2
elseif row_msg > 27
   high_f4 := 11
   high_f7 := row_msg - row_f4  - high_f4 - 3
   row_f7  := row_msg - high_f7 - 1
elseif row_msg > 24
   high_f4 := 9
   high_f7 := row_msg - row_f4  - high_f4 - 3
   row_f7  := row_msg - high_f7 - 1
endif

* +--------------------------------+
* | display boxes                  |
* +--------------------------------+
SETCOLOR (colors[2])
cls
out_box ( 2, 1)
out_box ( 3, 1)
out_box ( 4, 1)
repo_f6 ()                                         // display F4
out_box ( 5, 1)
out_box ( 7, 1, .T.)

* +--------------------------------+
* | check/enter report file        |
* +--------------------------------+
CLEAR TYPEAHEAD
if !repo_finame (@filename, @autocreate)           // enter/check
   SETCOLOR (oldcolor)
   RESTSCREEN (0,0, MAXROW(),MAXCOL(), screen)
   SavRestFN (fukeys)                              // restore user SET KEYs
   RETURN ""
endif

glfilename := filename

@ 1,0
SETCOLOR (colors[2])
@ 1,0 say RIGHT(filename, 14)

SETCOLOR (colors[3])                               // messages
@ 1,14 say text[1]

* +--------------------------------+
* | load report description        |
* +--------------------------------+
ok := repoload(glfilename, modify)
if !ok
   ALERT (text[40], {text[41]})                     // Quit Report Edit
   SETCOLOR (oldcolor)
   RESTSCREEN (0,0, MAXROW(),MAXCOL(), screen)
   SavRestFN (fukeys)                               // restore user SET KEYs
   return ""
endif

if autocreate
   autocrea()
endif

SetFnKey ()                                          // set key to default
SET KEY K_ESC  TO RepoEsc
SET KEY K_PGUP TO
SET KEY K_PGDN TO

window := 0 ; repo_f3 (.F.)                          // display F4
window := 0 ; repo_f4 (.F.)                          // display F4
window := 0 ; repo_f5 ()                             // display F5

window  := 2                                         // activate box F2
nextwin := K_F2

WHILE nextwin != K_ESC .and. nextwin != 0
   BEGIN SEQUENCE
      DO CASE
      case nextwin == K_F2
         repo_f2 (.T.)
         repo_f2 (.F.)
      case nextwin == K_F3
         repo_f3 (.T.)
         repo_f3 (.F.)
      case nextwin == K_F4
         repo_f4 (.T.)
         repo_f4 (.F.)
      case nextwin == K_F5
         window := 0
         repo_f5 (procname(), procline())
      case nextwin == K_F7
         repo_f7 ()
      otherwise
         nextwin := 0
      ENDcase
      out_box (window, 1)
      if nextwin == 0
         @ row_msg,0
         @ row_msg,0 SAY text[58]
         nextwin := INKEY(0)
         @ row_msg,0
      endif
   END
ENDDO

SavRestFN (fukeys)                              // restore user SET KEYs

select (oldselect)
SETCOLOR (oldcolor)
RESTSCREEN (0,0, MAXROW(),MAXCOL(), screen)

RETURN if (saved, trim(glfilename), "")

* +-------------------------------------------------------------------------+
* | enter/check report file name                                            |
* +-------------------------------------------------------------------------+
static function repo_finame (filename, autocreate)
local ok, locarr, ii
local getlist := {}

SETCOLOR (colors[1])
ok := VALTYPE(filename) == "C" .and. LEN(filename) > 0
if ok
   filename := trim(filename)
   ok = FILE(filename)
else
   filename := "        .frm" + space(50)
endif
modify := .T.                                              // global static

while !ok
   autocreate := .F.
   IF LEFT(filename,1) == " "
      @ 1,20 say text[33]
      @ 1,0 GET filename PICT "@S12"
      READ
      if LASTKEY() = K_ESC
         EXIT
      endif
   ELSE
      @ 1,0
      @ 1,0 SAY trim(filename)
   ENDIF
   if ! FILE (STRTRAN (filename, " ", ""))
      if USED()
         locarr := {text[57], text[40], text[59], text[41]}
      else
         locarr := {text[57], text[40], text[41]}
      endif
      ii = ALERT (text[38], locarr, colors[8])   // retry, create, [AutoCreate,]  Quit
      if ii == 1
         filename := "        .frm" + space(50)
         LOOP
      elseif ii == 2 .or. (ii == 3 .and. USED())
         if LEFT(filename,1) != " "
            modify := .F.
         endif
         autocreate := (ii == 3)
      else
         ok := .F.
         exit
      endif
   endif
   filename := STRTRAN (filename, " ", "")
   ok := .T.
enddo
return ok

* +-------------------------------------------------------------------------+
* | switch window for main menu                                             |
* +-------------------------------------------------------------------------+
static procedure SwitchWind (p1, p2, p3)
local get
nextwin := LASTKEY()
get := getactive()
out_box (window, 1)
if valtype(get) == "O"               // in GET/READ ?
   KEYBOARD chr(K_PGDN)              // yes, terminate it
endif
windend := .T.
** break
RETURN

* +-------------------------------------------------------------------------+
* | Window F2: specify page size                                            |
* |                                                                         |
* | F1 : f2_help() and back                                                 |
* | F3 : go to F3 window using switchwind, default                          |
* | F4 : go to F4 window using switchwind, default                          |
* | F5 : repo_f5() and back  (get field data),  default                     |
* | F6 : repo_f6() and back  (select database), default                     |
* | F7 : repo_f7() and back  (display report),  default                     |
* | F10: repoSave()and back  (save), default                                |
* +-------------------------------------------------------------------------+
STATIC FUNCTION REPO_F2 (input)
LOCAL ii
LOCAL oldtext := msg_txt
LOCAL getlist := {}

window  := 2
windend := .F.
saved   := .F.
nextwin := if (input, 0, nextwin)

SetFnKey ("--34567--0")                       // set key 3..7, 10
setkey   (K_F1,  {|x,y,z| F2_HELP (x,y,z)})

SETCOLOR (colors[1])
@ 3,1 CLEAR TO 10,49
out_box (2, if(input,2,1))

FOR ii := 1 to 8
   @ 2 + ii, 3 say text[1 + ii]
NEXT

msg_out (msg_txt:= text[26])

SETCOLOR (colors[if(input,2,7)])

DO WHILE !windend
   FOR ii := 1 to 4
      header[ii] = PADR (header[ii], max(data[REP_PG_WIDTH], 1))
      @ 2 + ii, 26 GET header[ii] PICT "@S" + ltrim(str(F2_WIDE))
   NEXT
   @  7, 26 GET data[REP_PG_WIDTH] PICT "999" RANGE 1,999
   @  7, 40 GET data[REP_PG_LINES] PICT "999" RANGE 1,999
   @  8, 26 GET data[REP_LEF_MARG] PICT "999" RANGE 0, data[REP_PG_WIDTH] -1
   @  8, 40 GET data[REP_RGT_MARG] PICT "999" RANGE 0, ;
                                  data[REP_PG_WIDTH] - data[REP_LEF_MARG] -1
   @  9, 28 GET data[REP_DBL_SPC ]
   @  9, 42 GET data[REP_PLAIN   ]
   @ 10, 28 GET data[REP_EJECT_BF]
   @ 10, 42 GET data[REP_EJECT_AF]
   if input
      READ
   else
      CLEAR GETS
      EXIT
   endif
   if updated()
      data[REP_TITLE] := arr_to_str (header)
      displ_f7 (row_f7 +1, high_f7 -1)
   endif
END
SETCOLOR (colors[1])
msg_txt := oldtext
SetFnKey ()                                   // set key to default
RETURN NIL

* +-------------------------------------------------------------------------+
* | Window F3: specify report columns                                       |
* |                                                                         |
* | F1 : f3_help() and back                                                 |
* | F2 : go to F2 window using switchwind, default                          |
* | F4 : go to F4 window using switchwind, default                          |
* | F5 : f3_f5()   and back  (get field data)                               |
* | F6 : repo_f6() and back  (select database), default                     |
* | F7 : repo_f7() and back  (display report),  default                     |
* | F10: repoSave()and back  (save), default                                |
* +-------------------------------------------------------------------------+
STATIC FUNCTION REPO_F3 (input)
LOCAL  ii, line, new, len := MAX_EXPR_STR, field_add, pict := "@S18"
local  lkey, outchr, outcolor
LOCAL  oldtext := msg_txt
MEMVAR getlist

window  := 3
windend := .F.
saved   := .F.
nextwin := if (input, 0, nextwin)

SetFnKey ("-2-4-67--0")                       // set key ...
setkey   (K_F1,  {|x,y,z| F3_HELP (x,y,z)})
setkey   (K_F5,  {|x,y,z| F3_F5   (x,y,z)})

SETCOLOR (colors[1])
@ 3,52 CLEAR TO 10,MAXCOL()-1
out_box (3, if(input,2,1))

outchr   := chr(if(input, 205, 196))
outcolor := if (input, colors[2], colors[1])

FOR ii := 1 to 8
   @ 2 + ii, 52 say text[17 + ii]
NEXT

msg_out (msg_txt:= text[28])
SETCOLOR (colors[if(input,2,7)])

do while !windend
   new := .F.
   field_add := if (input, "R", " ")
   IF currfld > data[REP_COLUMN_C]
      field_add := "A"
      newfield (infield, 0)                   // empty data
   else
      newfield (infield, currfld)             // available data
   endif

   clear typeahead
   SET KEY K_PGUP TO
   SET KEY K_PGDN TO

   @ 2, 52 + len(text[55]) +3 SAY replicate(outchr, 10) COLOR outcolor
   @ 2, 52 + len(text[55]) +3 SAY str(currfld,2) + "/" + ;
                                  str(data[REP_COLUMN_C],2) COLOR outcolor
   get_updated := .F.
   line := 3
   @ line++, 77 GET field_add PICT "!" WHEN  f3_mode(field_add) ;
                                       VALID f3_typ (field_add, infield)

   @ line++, 60 GET infield [REP_FLD_EXP] PICT pict ;
                                     VALID f3_expr(infield[REP_FLD_EXP])
   @ line++, 60 GET infield [REP_FLD_HEAD, 1] PICT pict VALID f3_wide(infield)
   @ line++, 60 GET infield [REP_FLD_HEAD, 2] PICT pict VALID f3_wide(infield)
   @ line++, 60 GET infield [REP_FLD_HEAD, 3] PICT pict VALID f3_wide(infield)
   @ line++, 60 GET infield [REP_FLD_HEAD, 4] PICT pict VALID f3_wide(infield)
   @ line  , 60 GET infield [REP_FLD_WIDTH]   PICT "999" ;
                                              WHEN  f3_wide(infield) ;
                                              VALID f3_check(infield)
   @ line++, 75 GET infield [REP_FLD_DECI] PICT "999" ;
                                           RANGE 0, infield[REP_FLD_WIDTH] -1
   @ line,   60 GET infield[REP_FLD_TOTAL]

   if input
      SET CONFIRM ON
      READ
      SET CONFIRM OFF
   else
      CLEAR GETS
      EXIT
   endif

   lkey := LASTKEY()
   if updated() .or. get_updated
      f3_wide(infield)                                    // check
   endif

   DO CASE
   CASE lkey == K_PGDN .or. lkey == K_ENTER               // next column
      if updated() .or. get_updated
         IF .not. f3_save (field_add, infield)            // save
            ?? chr(7)
            windend = .F.
         ENDIF
      endif
      if !windend
         if currfld >= data[REP_COLUMN_C]
            ?? chr(7)
         else
            currfld++
         endif
      endif
   CASE lkey == K_PGUP                                    // prev column
      if updated() .or. get_updated
         IF .not. f3_save (field_add, infield)            // save in fields[]
            ?? chr(7)                                     // and data[]
            windend = .F.
         ENDIF
      endif
      if !windend
         if currfld <= 1
            ?? chr(7)
         else
            currfld--
         endif
      endif
   CASE lkey == K_ESC                                     // prev column
      windend = .T.
   ENDCASE

   displ_f7 (row_f7 +1, 99)
enddo
msg_out (msg_txt := oldtext)
SETCOLOR (colors[1])
SetFnKey ()                                   // set key to default
RETURN NIL

static function newfield (arr, no)
LOCAL ii, len
if no > 0
   arr[REP_FLD_WIDTH] :=        fields[no, REP_FLD_WIDTH]
   arr[REP_FLD_DECI ] :=        fields[no, REP_FLD_DECI ]
   arr[REP_FLD_HEAD ] := ACLONE(fields[no, REP_FLD_HEAD ])
   arr[REP_FLD_EXP  ] :=        fields[no, REP_FLD_EXP  ]
   arr[REP_FLD_TOTAL] :=        fields[no, REP_FLD_TOTAL]
   arr[REP_FLD_TYPE ] :=        fields[no, REP_FLD_TYPE ]
   arr[REP_FLD_PICT ] :=        fields[no, REP_FLD_PICT ]
else
   arr[REP_FLD_WIDTH] := 0
   arr[REP_FLD_DECI ] := 0
   arr[REP_FLD_HEAD ] := {"","","",""}
   arr[REP_FLD_EXP  ] := ""
   arr[REP_FLD_TOTAL] := .F.
endif
len := arr[REP_FLD_WIDTH] + 80
arr[REP_FLD_EXP] := PADR (arr[REP_FLD_EXP], len)
for ii := 1 to LEN(arr[REP_FLD_HEAD])
   arr[REP_FLD_HEAD,ii] := PADR (arr[REP_FLD_HEAD,ii], len)
next
RETURN NIL

static function f3_expr (expr)
local row := row()
@ row,52 say " "
if empty(expr)
   return .F.
endif
if !(valtype(&(expr)) $ "CNDL")
   @ row,52 say "?" COLOR colors[9]
   return .F.
endif
return .T.

static function f3_mode (field_add)
local  ii, jj
@ 3,52 say text[18] color colors[4]        // redisplay current mode
jj := at(field_add, text[18])
while jj <= len(text[18]) .and. !(substr(text[18],jj,1) $ ",/:")
   @ 3, 52 + jj-1 say substr(text[18],jj,1) color colors[1]
   jj++
enddo
return .T.

static function f3_typ (field_add, infield)
local  ii
MEMVAR getlist
if !(field_add $ "ARDI")
   return .F.
endif
f3_mode(field_add)
if field_add $ "AI"                        // add, insert:
   if field_add $ "AI" .and. data[REP_COLUMN_C] >= MAX_FIELD_NO
      ALERT (text[54])
      RETURN .F.
   endif
   newfield (infield, 0)                   // prepare empty data
   for ii := 1 to len(getlist)             // redisplay get's
      getlist[ii]:display()
   next
elseif field_add == "D"
   keyboard chr(K_PGDN)
endif
return .T.

static function field_type (arr)
LOCAL xx, info, maxlen
MEMVAR  __dummy
PRIVATE __dummy

__dummy := arr[REP_FLD_EXP]
xx := TYPE(__dummy)

if xx $ "CMNLD"
   info := FIELDINFO (__dummy)
   if len(info) < 4
      info := ARRAY(4)
      info[2] := xx
      info[3] := arr[REP_FLD_WIDTH]
      info[4] := arr[REP_FLD_DECI ]
   endif
** maxlen := max(arr[1], info[3])
   maxlen := arr[1]
   xx := arr[REP_FLD_TYPE] := info[2]
   do case
   case xx == "C"
      arr[REP_FLD_PICT] := replicate("x",maxlen)
   case xx == "M"
      arr[REP_FLD_PICT] := replicate("x",maxlen)
   case xx == "L"
      arr[REP_FLD_PICT] := padr("T", maxlen, "-")
   case xx == "D"
      arr[REP_FLD_PICT] := padr(set (_SET_DATEFORMAT), maxlen, "-")
   case xx $ "NFI"
      arr[REP_FLD_PICT] := replicate("n",maxlen)
**    maxlen := max(info[4], arr[2])
      maxlen := arr[2]
      if maxlen > 0 .and. maxlen < len(arr[REP_FLD_PICT])
         arr[REP_FLD_PICT] := STRPOKE (arr[REP_FLD_PICT], ;
                                       LEN(arr[REP_FLD_PICT]) - maxlen, ;
                                       ASC("."))
      endif
   endcase
endif
return NIL

* +-------------------------------------------------------------------------+
* | show dbf fields using F5 being in F3 window                             |
* | overtake  field into GET                                                |
* +-------------------------------------------------------------------------+
static function f3_f5 (p1, p2, p3)
local get := getactive()
local aField, aSubscr, ii
LOCAL elem1, elem2, elem3, value
MEMVAR getlist

aField := repo_f5 (procname())
if !empty(aField) .and. upper(trim(get:name)) == "INFIELD"
   aSubscr := get:subscript

   elem1  := if (len(aSubscr) >  0, aSubscr[1], 0)
   elem2  := IF (LEN(aSubscr) >= 2, aSubscr[2], 0)
   elem3  := IF (LEN(aSubscr) >= 3, aSubscr[3], 0)

   do case
   case elem1 == REP_FLD_EXP .or. elem1 == REP_FLD_HEAD
      value := trim(get:varget())
      value += if (!empty(value), " + ", "")
      do case
      case elem1 != REP_FLD_EXP .or. empty(value) .or. aField[2] == "C"
         value += trim(alias()) + "->" + trim(aField[1])
      case aField[2] $ "NFI"
         value += "str(" + trim(alias()) + "->" + trim(aField[1]) + ;
                  "," + ltrim(str(aField[3])) + ;
                  "," + ltrim(str(aField[4])) + ")"
         infield[REP_FLD_DECI] := aField[4]
         get_updated := .T.
      case aField[2] == "D"
         value += "dtoc(" + trim(alias()) + "->" + trim(aField[1]) + ")"
      case aField[2] == "L"
         value += "if(" + trim(alias()) + "->" + trim(aField[1]) + "'1','0')"
      otherwise
         value += trim(alias()) + "->" + trim(aField[1])
      endcase
      value := PADR (value, MAX_EXPR_STR)
      get:varput(value)
      infield[REP_FLD_WIDTH] += aField[3]
      get_updated := .T.
   case elem1 == REP_FLD_WIDTH
      get:varput(aField[3])
      get_updated := .T.
   case elem1 <= REP_FLD_DECI
      get:varput(aField[4])
      get_updated := .T.
   endcase
endif
for ii := 1 to len(getlist)
   getlist[ii]:display()
next
return NIL

static function f3_wide(arr)        // WHEN function
local maxlen
maxlen := f3_maxfld (arr)
if maxlen > arr[REP_FLD_WIDTH]
   arr[REP_FLD_WIDTH] := maxlen
endif
RETURN .T.

static function f3_check(arr)       // VALID function
local maxlen
maxlen := f3_maxfld (arr)
RETURN maxlen <= arr[REP_FLD_WIDTH]

static function f3_maxfld(arr)
LOCAL ii, maxlng := arr[REP_FLD_WIDTH], len_head := 0, len_eval := 0, dummy
FOR ii := 1 to 4
   len_head := MAX( len_head, LEN( TRIM( arr[REP_FLD_HEAD,ii] )))
NEXT
if !empty(arr[REP_FLD_EXP]) .and. "+" $ arr[REP_FLD_EXP]
   dummy := &(trim(arr[REP_FLD_EXP]))
   do case
   case valtype(dummy) == "C"
      len_eval := len(dummy)
   case valtype(dummy) $ "NFI"
      len_eval := 10
   case valtype(dummy) == "D"
      len_eval := 8
   case valtype(dummy) == "L"
      len_eval := 1
   endcase
endif
return max (len_head, len_eval)

static function f3_save (field_add, arr)
* field_add : "AIDR"
* arr       : infield[]
LOCAL getlist :={}, savescr, saveesc, input := 0

field_type (arr)                                // fill arr[6,7] = type, pict
if VALTYPE(arr[REP_FLD_PICT]) == "C" .and. LEN(arr[REP_FLD_PICT]) > arr[REP_FLD_WIDTH]
   arr[REP_FLD_WIDTH] := LEN(arr[REP_FLD_PICT])
   f3_wide (arr)                                // new field width
endif

DO CASE
CASE field_add == "I" .and. data[REP_COLUMN_C] < 1
   field_add := "A"
CASE field_add == "R" .and. currfld > data[REP_COLUMN_C]
   field_add := "A"
ENDCASE

if field_add $ "AI" .and. data[REP_COLUMN_C] >= MAX_FIELD_NO // validate max
   ALERT (text[54])
   currfld := data[REP_COLUMN_C] := MAX_FIELD_NO
   RETURN .F.
endif

DO CASE
CASE field_add == "R"                             // replace column
   fields [currfld] := ACLONE (arr)
CASE field_add == "A"                             // add column
   currfld := data[REP_COLUMN_C] + 1
   data[REP_COLUMN_C] := currfld
   fields [currfld] := ACLONE (arr)
CASE field_add == "I"                             // insert column
   AINS (fields, currfld)
   fields[currfld] := ACLONE (arr)
   currfld := data[REP_COLUMN_C] + 1
   data[REP_COLUMN_C] := currfld
CASE field_add == "D"                             // delete column
   if data[REP_COLUMN_C] >= currfld
      ADEL (fields, currfld)
      data[REP_COLUMN_C]--
      IF currfld > data[REP_COLUMN_C]
         currfld := data[REP_COLUMN_C]
      ENDIF
   else
      RETURN .F.
   endif
ENDCASE
RETURN .T.

* +-------------------------------------------------------------------------+
* | specify group headins in window F4                                      |
* +-------------------------------------------------------------------------+
STATIC FUNCTION REPO_F4 (input)
LOCAL ii, jj, r1, r2, line, len, pict := "@S" + ltrim(str(F2_WIDE))
LOCAL grprow := {14,15,14,15}, subrow := {18,18,18,18}
LOCAL oldtext := msg_txt
MEMVAR getlist

SetFnKey ("-23--67--0")                       // set key 2..7, 10
setkey   (K_F1,  {|x,y,z| F4_HELP (x,y,z)})
setkey   (K_F5,  {|x,y,z| F4_F5   (x,y,z)})

len := data[REP_PG_WIDTH] +1

SETCOLOR (colors[1])
@ row_f4,26 CLEAR TO row_f4+high_f4-1,49

for ii := 1 to 4
   grphead[ii] := subhead[ii] := space(len)
next
if VALTYPE(data[REP_GRP_HEAD]) == "C"
   grphead := __splittxt (data[REP_GRP_HEAD], 4)
endif
if VALTYPE(data[REP_SUB_HEAD]) == "C"
   subhead := __splittxt (data[REP_SUB_HEAD], 4)
endif
for ii := 1 to 4
    grphead[ii] = PADR(grphead[ii], len)
    subhead[ii] = PADR(subhead[ii], len)
next
data[REP_GRP_EXP]= if( data[REP_GRP_EXP]==NIL, space(MAX_EXPR_STR), ;
                       PADR(data[REP_GRP_EXP],MAX_EXPR_STR))
data[REP_SUB_EXP]= if( data[REP_SUB_EXP]==NIL,space(MAX_EXPR_STR), ;
                       PADR(data[REP_SUB_EXP],MAX_EXPR_STR))

ii := row_f4
@ ii++, 3 SAY text[10]           // group expr
@ ii++, 3 SAY text[11]           // group head #1
@ ii++, 3 SAY text[12]           // group head #2
if high_f4 > 6
   @ ii++, 3 SAY text[13]        // group head #3
   @ ii++, 3 SAY text[14]        // group head #4
   grprow := {14,15,16,17}
   subrow := {20,21,20,21}
endif
@ ii++, 3 SAY text[15]           // summary/eject
@ ii++, 3 SAY text[16]           // subgroup expr
jj := 11
while ii <= (row_f4 + high_f4 -1)
   @ ii++, 3 SAY text[jj++]      // subgroup head 1..4
enddo

window  := 4
windend := .F.
saved   := .F.
nextwin := if (input, 0, nextwin)
msg_out (msg_txt:= text[27])

out_box (4, if(input,2,1))

SETCOLOR (colors[if(input,2,7)])

DO WHILE !windend

   get_updated := .F.
   line := row_f4
   @ line++,   26 GET data[REP_GRP_EXP] PICT pict VALID f4_exp()
   @ grprow[1], 26 GET grphead[1]  PICT pict WHEN f4_outnr() ; line++
   @ grprow[2], 26 GET grphead[2]  PICT pict WHEN f4_outnr() ; line++
   if high_f4 > 6 .or. input
      @ grprow[3], 26 GET grphead[3]  PICT pict WHEN f4_outnr()
      @ grprow[4], 26 GET grphead[4]  PICT pict WHEN f4_outnr()
   endif
   line := grprow[4] +1
   @ line  , 26 GET data[REP_SUMMARY] WHEN f4_displ (grprow, grphead, pict)
   @ line++, 32 GET data[REP_EJECT  ]
   @ line++, 26 GET data[REP_SUB_EXP] PICT pict
   for jj := 1 to 4
      if !input .and. line > (row_f4 + high_f4 -1)
         exit
      endif
      @ subrow[jj], 26 GET subhead[jj] PICT pict WHEN f4_outnr()
      line := subrow[jj] +1
   next
   if input
      READ
   else
      CLEAR GETS
      EXIT
   endif
   if updated() .or. get_updated
      data[REP_GRP_HEAD] := arr_to_str (grphead)
      data[REP_SUB_HEAD] := arr_to_str (subhead)
      displ_f7 (row_f7 +1, high_f7 -1)
   endif
END
SETCOLOR (colors[1])
msg_out (msg_txt := oldtext)
SetFnKey ()                                       // set key to default
RETURN NIL

static function f4_displ (grprow, grphead, pict)  // redisplay group header
local ii, line := 0
if grprow[4] < grprow[1] +3
   for ii := 1 to 4
      if grprow[ii] > line
         line := grprow[ii]
         @ line, 22 SAY str(ii,1)   COLOR colors[7]
         colorselect (1)
          @ line, 26 SAY grphead[ii] PICT pict
         colorselect (0)
      endif
   next
endif
return .T.

static function f4_outnr()
LOCAL get := getactive()
LOCAL col := col(), row := row()
@ get:ROW,22 SAY str(get:SUBSCRIPT[1],1)
SETPOS (row, col)
return .T.

static function f4_exp ()
local get := getactive()
PRIVATE __dummy
__dummy := get:varget()
if type(M->__dummy) != "C"
   alert ("Warning, invalid expression")
endif
return .T.

static function f4_f5 (p1, p2, p3)
local get := getactive()
local aField, aSubscr, ii, value
LOCAL elem1
MEMVAR getlist

aField := repo_f5 (procname())
if !empty(aField)
   aSubscr := get:subscript
   elem1   := if (len(aSubscr) >  0, aSubscr[1], 0)
   do case
   case upper(trim(get:name)) == "DATA" .and. ;
        elem1 == REP_GRP_EXP .or. elem1 == REP_SUB_EXP
      value := trim(get:varget())
      value += if (!empty(value), " + ", "")
      value += trim(alias()) + "->" + trim(aField[1])
   case upper(trim(get:name)) == "GRPHEAD"
      value := trim(get:varget())
      value += if (!empty(value), " ", "") + trim(aField[1])
   endcase
   if value != NIL
      get:varput(value)
      get_updated := .T.
      for ii := 1 to len(getlist)
         getlist[ii]:display()
      next
   endif
endif
return NIL

* +-------------------------------------------------------------------------+
* | show dbf fields using F5                                                |
* +-------------------------------------------------------------------------+
STATIC FUNCTION REPO_F5 (p1, p2, p3)
* p1,p2,p3 = NIL : display only
* otherwise      : return field specs (name, type, len)

LOCAL aDbfData[0], aOut[0], ii, oldwindow := window
LOCAL choice := 0
LOCAL actcolor := SETCOLOR(), oldselect := SELECT()
LOCAL bottom_row := row_f4 + high_f4
LOCAL oldtext := msg_txt, saveF5

CLEAR TYPEAHEAD
if !used() .or. window = 5
   RETURN NIL
endif

saveF5 := setkey (K_F5)
SET KEY K_F5 TO                            // disable F5

window  := 5
nextwin := 0
Out_box (oldwindow, 1)
** out_box (1, 2)

do while .T.
   aDbfData := DBSTRUCT()

   FOR ii := 1 to len(aDbfData)
      aadd (aOut, PADR(aDbfData[ii,1],11) + aDbfData[ii,2] + ;
                 STR(aDbfData[ii,3],4) +  STR(aDbfData[ii,4],4))
   NEXT

   @ row_f4,56 clear to bottom_row-1,75

   if empty(p1)                                // SET KEY ... TO ?
      setcolor (colors[4])
      achoice (row_f4,56, bottom_row-1,75, aOut, .F.)
      setcolor (actcolor)
   else
      SET KEY K_F6 TO f5_f6                // spec.handling next dbf
      f5f6_flag := .F.
      out_box (5, 2)
      msg_out (msg_txt:= text[26])
      choice = achoice (row_f4,56, bottom_row-1,75, aOut, .t., , lastchoice)
      SET KEY K_F6   TO repo_f6
      if f5f6_flag
         inkey()
         aout := array(0)
         choice := 0
         loop
      endif
   endif
   exit
enddo

out_box (5, 1)
msg_out (msg_txt := oldtext)
out_box (oldwindow, 2)

window := oldwindow
setkey (K_F5, saveF5)                        // enable F5

if empty(p1) .or. choice == 0
   RETURN NIL
endif
RETURN aDbfData[choice]

* +-------------------------------------------------------------------------+
* | get next .dbf (F6 key) being in F5                                      |
* +-------------------------------------------------------------------------+
static function f5_f6 (p1, p2, p3)
repo_f6(procname())
keyboard chr(13)
f5f6_flag := .T.
return NIL

* +-------------------------------------------------------------------------+
* | get next .dbf (F6 key)                                                  |
* +-------------------------------------------------------------------------+
STATIC FUNCTION REPO_F6 (p1, p2, p3)
* p1,p2,p3 == NIL : display current .dbf only
*    p2,p3 == NIL : select next dbf, don't display

LOCAL ii, actselect := SELECT()
LOCAL row := row(), col := col()

if !used()
   return NIL
endif

if window > 0 .and. p1 != NIL
   for ii := actselect +1 to 255
      select (ii)
      if used()
         exit
      endif
   next
   if ii > 255
      for ii := 1 to actselect
         select (ii)
         if used()
            exit
         endif
      next
   endif
end

lastchoice := 1
dbfname := DBF()
if dbfname != NIL .and. !empty(dbfname)
   if !("." $ dbfname)
      dbfname := trim(dbfname) + ".dbf"
   end
   if len(dbfname) > 21
      dbfname := "..." + right(dbfname,17)
   end
endif

out_box ( 5, if(window==5,2,1))
@ row_f4 -1, 55 say dbfname
if !(p2 == NIL)
   repo_f5 ()
endif
setpos (row, col)

return NIL

* +-------------------------------------------------------------------------+
* | display data in window F7 full screen                                   |
* +-------------------------------------------------------------------------+
STATIC FUNCTION REPO_F7 ()
LOCAL savescr, savecol, saveesc, r1, r2, hi, fullarr, disparr, dummy
LOCAL ii, jj, elem, oldwindow := window
LOCAL oldtext := msg_txt
MEMVAR f7_leftcol, f7_width

PRIVATE f7_leftcol, f7_width := 0

fullarr := displ_f7 (0, 99, .T.)                           // prepare data
elem    := LEN(fullarr)
if elem = 0
   ?? chr(7)
   RETURN NIL
endif

SetFnKey ("-23456---0")                       // set key 2..6, 10

window  := 7
nextwin := 0
out_box (oldwindow, 1)
out_box (7, 2, .t.)                                        // display box

for ii = 1 TO elem
   f7_width := max (f7_width, LEN(fullarr[ii]))
next

asize (fullarr, len(fullarr) +1)
ains  (fullarr, 1)
fullarr[1] := space(5)
for ii := 1 to f7_width -5
   fullarr[1] += if (ii % 10 == 0, str((ii/10) % 10, 1), ;
                 if (ii %  5 == 0, ":", ".") )
next
jj := 100
while (ii := at(".0", fullarr[1])) > 0
   dummy := ltrim(str(jj))
   fullarr[1] := stuff (fullarr[1], ii + 2 - len(dummy), len(dummy), dummy)
   jj += 100
end

elem++
disparr := ARRAY(elem)

r2 := row_msg -1

if elem < high_f7
   r1 := row_f7 -1
   hi := high_f7
else
   hi := min (r2-4, elem)
   r1 := r2 - hi -1
endif

savecol := SETCOLOR()
savescr := SAVESCREEN (r1, 0, r2, MAXCOL())
saveesc := SETKEY (K_ESC)

setcolor (colors[2])
@ r1,0 CLEAR TO r2, MAXCOL()                               // draw F7 box
@ r1,0 TO r2, MAXCOL() DOUBLE

if f7_width > MAXCOL() -1                                  // enable CuLe,CuRi
   SET KEY K_LEFT  TO f7_left
   SET KEY K_RIGHT TO f7_right
endif

SET KEY K_ESC TO                                           // disable Esc
for ii := 1 to 10                                          // when F1..F10:
   setkey (k_keys[ii], {|| __keyboard(chr(K_ESC)) })       // simulate ESC
next

dummy   := text[56] + ltrim(str(oldwindow))                // back to Fx
msg_txt := text[30] + space(79 -len(dummy + text[30])) + dummy
msg_out (msg_txt)                                          // bottom msg
setcolor (colors[6])

f7_leftcol := 1
ii := 1
do while f7_leftcol > 0
   if f7_width > MAXCOL() -1
      for jj := 1 to elem
         disparr [jj] := PADR(SUBSTR (fullarr[jj], f7_leftcol), 78)
      next
   else
      disparr := ACLONE(fullarr)
   endif
   @ r1+1,1 CLEAR TO r2-1, MAXCOL()-1
   ii := ACHOICE (r1 +1, 1, r2-1, MAXCOL() -1, disparr, .T., ii)
   if lastkey() == K_ESC
      EXIT
   endif
enddo

SET KEY K_LEFT  TO
SET KEY K_RIGHT TO
SETKEY (K_ESC, saveesc)
SetFnKey ()                                       // set key to default
setcolor (savecol)
RESTSCREEN (r1, 0, r2, MAXCOL(), savescr)

out_box (7, 1, .T.)
out_box (oldwindow, 2)

window := oldwindow
msg_out (msg_txt := oldtext)
RETURN NIL

static function f7_left
MEMVAR f7_leftcol, f7_width
if f7_leftcol > 1
   f7_leftcol := max (f7_leftcol -10, 1)
   KEYBOARD chr(K_ENTER)
endif
RETURN NIL

static function f7_right
MEMVAR f7_leftcol, f7_width
if f7_leftcol < f7_width - MAXCOL() - 1
   f7_leftcol += 10
   KEYBOARD chr(K_ENTER)
endif
RETURN NIL

* +-------------------------------------------------------------------------+
* | display data in window F7 from save[]                                   |
* +-------------------------------------------------------------------------+
static function displ_f7 (first, lines, full, len_only)
LOCAL out := 0, elem := 1, disparr[lines], arr, fldarr, rr, sii, dummy, kk
LOCAL fld_headers := 0, arr_f3[7], pos_col[1,2], arr_f3_elem := 1, posbeg
LOCAL ii, jj, ee
LOCAL txx := {"PgHd", "GrHd", "SubH", "TxtD", "Colu", "Data"}

if lines <= 0
   RETURN NIL
endif
data_to_save()                                             // copy data[] to save[]
* +--------------------------------+
* | fill data in disparr[]         |
* +--------------------------------+
if VALTYPE(save[REP_TITLE]) == "C"                         // display header
   arr := __splittxt(save[REP_TITLE])
   ii  := 1
   while ii <= LEN(arr) .and. elem <= lines
      disparr[elem++] := txx[1] + ":" + arr[ii++]          // PgHd: xxxxx
   end                                                     //[PgHd: xxxxx]
endif
if VALTYPE(save[REP_GRP_HEAD]) == "C" .and. elem <= lines  // group header
   arr := __splittxt(save[REP_GRP_HEAD])
   ii  := 1
   while ii <= LEN(arr) .and. elem <= lines
      disparr[elem++] := txx[2] + ":" + arr[ii++]          // GrHd: xxxxx
   end                                                     //[GrHd: xxxxx]
endif
if save[REP_COLUMN_C] > 0 .and. elem <= lines              // field columns
   disparr[elem] := txx[5] + ":"                           // Coln: xxxxx
   pos_col := ARRAY(save[REP_COLUMN_C],2)                  //[Coln: xxxxx]
   posbeg  := 6
   for ii := 1 to data[REP_COLUMN_C]
      sii := ltrim(str(ii))
      jj  := fields [ii,REP_FLD_WIDTH]
      kk  := LEN (sii) +2
      if jj < kk
         disparr[elem] += PADR(substr(sii, -jj), jj +1)
      elseif jj == kk
         disparr[elem] += PADR("["+sii+"]", jj +1)
      else
         dummy := "[" + replicate("-", int((jj-LEN(sii)-2)/2) ) + sii
         disparr[elem] += dummy + replicate ("-", jj - LEN(dummy) -1) + "] "
      endif
      pos_col[ii,1] := posbeg
      pos_col[ii,2] := posbeg + jj -1
      posbeg += jj +1
   next
   arr_f3 [arr_f3_elem++] := disparr[elem]
   elem++
endif
if len_only != NIL
   if len_only
      RETURN LEN(disparr[elem -1])
   endif
endif

if save[REP_COLUMN_C] > 0 .and. elem <= lines              // fields
   fldarr := f7_fields()
   fld_headers := LEN(fldarr)
   ii  := 1
   while ii <= fld_headers .and. elem <= lines
      disparr[elem] := txx[if(ii<>fld_headers,4,6)] + ":" + fldarr[ii++]
      arr_f3 [arr_f3_elem++] := disparr[elem++]
   end
endif
if VALTYPE(save[REP_SUB_HEAD]) == "C"
   if LEN(save[REP_SUB_HEAD]) > 0 .and. elem <= lines     // subgroup header
      arr := __splittxt(save[REP_SUB_HEAD])
      ii  := 1
      while ii <= LEN(arr) .and. elem <= lines
         disparr[elem++] := txx[3] + ":" + arr[ii++]
      end
      if save[REP_COLUMN_C] > 0 .and. elem <= lines       // fields
         ii  := 1
         while ii <= LEN(fldarr) .and. elem <= lines
            disparr[elem] := txx[if(ii<>fld_headers,4,6)] + ":" + fldarr[ii++]
         end
      endif
   endif
endif

if arr_f3[arr_f3_elem] == NIL .and. arr_f3_elem > 1
   arr_f3_elem--
endif

if elem <= lines
   if disparr[elem] == NIL
      elem--
   endif
else
   elem := lines
endif

* +--------------------------------+
* | display from disparr[]         |
* +--------------------------------+
if full == NIL
   @ row_f7,1 CLEAR TO row_f7 + high_f7 -1, MAXCOL()-1
   rr := row_f7 + high_f7 -1
   jj := elem
   IF window == 3                                          // display fields
      jj := arr_f3_elem
      kk := 1
      if currfld <= len(pos_col) .and. !empty(pos_col[currfld,2])  // place current
         if pos_col[currfld,2] > 78                        // field in window
            kk := pos_col[currfld,2] -78 +1
            if kk > pos_col[currfld,1]
               kk := pos_col[currfld,1]
            endif
         endif
      endif
      if high_f7 <= arr_f3_elem
         @ row_f7, 1 SAY SUBSTR(arr_f3[1],kk,78)
         jj := arr_f3_elem
         ee := MIN (high_f7 -1, arr_f3_elem -1)
      else
         ee := MIN (high_f7 -1, elem)
      endif
      f7_out (ee, jj, arr_f3, kk, rr)
   ELSEIF window == 4                                      // display group
      f7_out (MIN (high_f7 -1, elem), jj, disparr, 1, rr)
   ELSE
      for ii = 1 TO MIN(lines, elem)                       // display header
         @ first++,1 SAY SUBSTR(disparr[ii],1,78)
      next
   ENDIF
   RETURN NIL
endif

ASIZE (disparr, elem)
RETURN disparr

static function f7_out (ee, jj, arr, kk, rr)   // display arr backwise
LOCAL ii
for ii = 1 to ee
   if jj > 0 .and. jj <= len(arr)
      if valtype(arr[jj]) == "C" .and. kk > 0
         @ rr--, 1 SAY SUBSTR(arr[jj],kk,78)
      endif
      jj--
   endif
next
return NIL

static function f7_fields ()
LOCAL maxfldhead := 1, arr, dummy
LOCAL_INT jj, ii

for jj := 4 to 1 STEP -1                                   // determine no of
   for ii := 1 to data[REP_COLUMN_C]                       // header lines
      if !empty (fields[ii, REP_FLD_HEAD, jj])
          maxfldhead := jj
         jj := 0
         EXIT
      endif
   next
next

arr := ARRAY (maxfldhead +1)
AFILL (arr, "")

for ii := 1 to data[REP_COLUMN_C]                          // all columns
   for jj := 1 to maxfldhead                               // all head lines
      arr [jj] += PADR (fields [ii,REP_FLD_HEAD,jj],       ;
                        max(1, fields [ii,REP_FLD_WIDTH]) )
      arr [jj] += " "
   next
   if VALTYPE(fields[ii, REP_FLD_TYPE]) $ "CMNLD" .and. ;
      VALTYPE(fields[ii, REP_FLD_PICT]) == "C"
      if fields[ii, REP_FLD_TYPE] $ "NFI"
         dummy := PADL (fields[ii, REP_FLD_PICT], ;
                        max(1, fields [ii,REP_FLD_WIDTH]))
      else
         dummy := PADR (fields[ii, REP_FLD_PICT], ;
                        max(1, fields [ii,REP_FLD_WIDTH]))
      endif
   else
      dummy := REPLICATE ("x", max(1, fields [ii,REP_FLD_WIDTH]))
      if fields [ii,REP_FLD_DECI] > 0 .and. ;
         fields [ii,REP_FLD_DECI] < fields [ii,REP_FLD_WIDTH]
         STRPOKE (@dummy, LEN(dummy) - fields [ii,REP_FLD_DECI], ASC("."))
      endif
   endif
   arr [maxfldhead +1] += dummy + " "
next
RETURN arr

* +-------------------------------------------------------------------------+
* | autocreate from current .dbf                                            |
* +-------------------------------------------------------------------------+
STATIC FUNCTION AUTOCREA ()
LOCAL ii, arr
arr := dbstruct()
for ii := 1 TO MIN(LEN(arr), MAX_FIELD_NO)
   data[REP_COLUMN_C] := ii
   fields[ii, REP_FLD_WIDTH ] := MAX( arr[ii,3], LEN(arr[ii,1]))
   fields[ii, REP_FLD_HEAD,1] := arr[ii,1]
   fields[ii, REP_FLD_EXP   ] := alias() + "->" + arr[ii,1]
   fields[ii, REP_FLD_TYPE  ] := arr[ii,2]
   do case
   case arr[ii,2] == "C"
      fields[ii, REP_FLD_PICT] := replicate("x",arr[ii,3])
   case arr[ii,2] == "M"
      fields[ii, REP_FLD_PICT] := replicate("x",10)
   case arr[ii,2] == "L"
      fields[ii, REP_FLD_PICT] := "T"
   case arr[ii,2] == "D"
      fields[ii, REP_FLD_PICT] := set (_SET_DATEFORMAT)
   case arr[ii,2] $ "NFI"
      fields[ii, REP_FLD_PICT] := replicate("n",arr[ii,3])
      if arr[ii,4] > 0
         fields[ii, REP_FLD_PICT] := STRPOKE (fields[ii, REP_FLD_PICT], ;
                  LEN(fields[ii, REP_FLD_PICT]) - arr[ii,4], ASC("."))
      endif
      fields[ii, REP_FLD_DECI] := arr[ii,4]
   endcase
next
ii := displ_f7 (0, 99, , .T.)
data[REP_PG_WIDTH] := ii -5

return NIL

* +-------------------------------------------------------------------------+
* | prepare data storage                                                    |
* +-------------------------------------------------------------------------+
STATIC FUNCTION data_to_save ()
LOCAL ii, arr[REP_FLD_SIZE]

save[REP_TITLE   ] := arr_to_str (header)
save[REP_GRP_EXP ] := if (empty(data[REP_GRP_EXP ]), NIL, TRIM(data[REP_GRP_EXP ]))
save[REP_SUB_EXP ] := if (empty(data[REP_SUB_EXP ]), NIL, TRIM(data[REP_SUB_EXP ]))
save[REP_GRP_HEAD] := arr_to_str (grphead)
save[REP_SUB_HEAD] := arr_to_str (subhead)
save[REP_PG_WIDTH] := data[REP_PG_WIDTH]
save[REP_PG_LINES] := data[REP_PG_LINES]
save[REP_LEF_MARG] := data[REP_LEF_MARG]
save[REP_RGT_MARG] := data[REP_RGT_MARG]
save[REP_COLUMN_C] := data[REP_COLUMN_C]
save[REP_DBL_SPC ] := data[REP_DBL_SPC ]
save[REP_SUMMARY ] := data[REP_SUMMARY ]
save[REP_EJECT   ] := data[REP_EJECT   ]
save[REP_EJECT_BF] := data[REP_EJECT_BF]
save[REP_EJECT_AF] := data[REP_EJECT_AF]
save[REP_PLAIN   ] := data[REP_PLAIN   ]
save[REP_FIELDS  ] := {}

if data[REP_COLUMN_C] > 0
   save[REP_FIELDS] := ARRAY (data[REP_COLUMN_C])
   FOR ii := 1 to data[REP_COLUMN_C]
      arr[REP_FLD_WIDTH]  := fields[ii, REP_FLD_WIDTH]
      arr[REP_FLD_DECI ]  := fields[ii, REP_FLD_DECI ]
      arr[REP_FLD_HEAD ]  := arr_to_str(fields[ii, REP_FLD_HEAD])
      arr[REP_FLD_EXP  ]  := TRIM(fields[ii, REP_FLD_EXP] )
      arr[REP_FLD_TOTAL]  := fields[ii, REP_FLD_TOTAL]
      save[REP_FIELDS,ii] := ACLONE (arr)
   NEXT
endif
return NIL

*+---------------------------------------------------------+
*| service: create string with embedded ; from array       |
*+---------------------------------------------------------+
STATIC FUNCTION arr_to_str (arr)
LOCAL ret := "", ii, maxsize, dummy

FOR maxsize := LEN(arr) to 1 STEP -1
   if !empty(arr[maxsize])
      exit
   endif
NEXT
FOR ii := 1 TO maxsize
   dummy := TRIM(arr[ii])
   ret += if (dummy == ".", " ", dummy)
   if ii != maxsize
      ret += ";"
   endif
NEXT
RETURN ret

*+---------------------------------------------------------+
*| service: output box with header and specif.color        |
*+---------------------------------------------------------+
STATIC FUNCTION OUT_BOX (boxno, type, f7_yes)
* boxno    = 2..7
* type     = 1/2 single/double
* [f7_yes] = display F7

LOCAL r1, r2, c1, c2, txt
LOCAL actcolor := SETCOLOR()

DO CASE
CASE boxno = 2
   r1 := row_f2 -1 ; c1 := 0
   r2 := row_f2 + high_f2 ; c2 := 50 ; txt := "F2"
CASE boxno = 3
   r1 := row_f2 -1 ; c1 := 51
   r2 := row_f2 + high_f2 ; c2 := MAXCOL()
   txt:= "F3:" + text[55] + " " + ;
         if (valtype(currfld) $ "NFI", str(currfld,2), " 0") + "/" + ;
         if (!empty(data[REP_COLUMN_C]), str(data[REP_COLUMN_C],2), " 0")
CASE boxno = 4
   r1 := row_f4 -1 ; c1 := 0
   r2 := row_f4 + high_f4 ; c2 := 50 ; txt := "F4"
CASE boxno = 5
   r1 := row_f4 -1 ; c1 := 51
   r2 := row_f4 + high_f4 ; c2 := MAXCOL() ; txt := "F5:" + dbfname
CASE boxno = 7
   if high_f7 < 2
      return NIL
   endif
   r1 := row_f7 -1 ; c1 := 0
   r2 := row_f7 + high_f7 ; c2 := MAXCOL()
   txt:= if (f7_yes != NIL, "F7", "")
OTHERWISE
   return NIL
ENDCASE

if type = 2
   SETCOLOR(colors[2])
   @ r1,c1 TO r2,c2 DOUBLE
else
   SETCOLOR(colors[1])
   @ r1,c1 TO r2,c2
endif
@ r1,c1+1 SAY txt
if boxno = 5
   @ r2, c2 - len(text[31]) say text[31]
elseif boxno = 7
   @ row_f7, c1+1 say "....,....1....,....2....,....3....,....4....,....5....,....6....,....7....,..."
endif

SETCOLOR(actcolor)
RETURN NIL

*+---------------------------------------------------------+
*| service: output msg line                                |
*+---------------------------------------------------------+
STATIC FUNCTION msg_out (msg)
@ row_msg, 0
** @ row_msg, int((MAXCOL() - len(msg)) / 2) SAY msg COLOR colors[3]
@ row_msg, 0 SAY msg COLOR colors[3]
RETURN NIL

*+---------------------------------------------------------+
*| save/restore F1..F10, PgUp,PgDn,Esc                     |
*+---------------------------------------------------------+
STATIC FUNCTION SavRestFN (input)
* input : "C" = "1234567890UDE" save key 1..13 and disable it if not "-"
*         return = savkey[13]
* input : "A" == savkey[13]

local savkey[13]
local ii

if valtype(input) == "A"
   for ii := 1 to 13
      if valtype(input[ii]) == "B"
         SETKEY (k_keys[ii], input[ii])
      endif
   next
   RETURN NIL
endif

for ii := 1 to 13
   savkey[ii] := SETKEY (k_keys[ii])
   if len(input) >=ii .and. !(substr(input,ii,1) $ "-! ") // -!sp: don't disable
      SETKEY (k_keys[ii], NIL)
   endif
next
return savkey

static function SetFnKey (mask)
*------------------------------------------------------------------------
LOCAL_INT ii
if mask == NIL
   mask := "1234567890"
endif
for ii := 1 to 10
   setkey (k_keys[ii],  NIL)                                   // disable all
   do case
   case ii >= 2 .and. ii <= 4 .and. strpeek(mask,ii) != asc("-")   // F2..F4
      setkey (k_keys[ii],  {|x,y,z| SwitchWind (x,y,z)})
   case ii == 5 .and. strpeek(mask,ii) != asc("-")                 // F5
      setkey (k_keys[ii], {|x,y,z| REPO_F5  (x,y,z)})
   case ii == 6 .and. strpeek(mask,ii) != asc("-")                 // F6
      setkey (k_keys[ii], {|x,y,z| REPO_F6  (x,y,z)})
   case ii == 7 .and. strpeek(mask,ii) != asc("-")                 // F7
      setkey (k_keys[ii], {|x,y,z| REPO_F7  (x,y,z)})
   case ii == 10 .and. strpeek(mask,ii) != asc("-")                // F10
      setkey (k_keys[ii], {|x,y,z| RepoSave  (x,y,z)})
   endcase
next
return NIL

* +-------------------------------------------------------------------------+
* | load or set default report data                                         |
* +-------------------------------------------------------------------------+
STATIC FUNCTION RepoLoad (file, modify)
LOCAL_INT ii

AFILL (header,  "")
AFILL (grphead, "")
AFILL (subhead, "")

if modify                                     // read old .frm
   data := aclone(__reportst (trim(file)))    // FS library function
   if !(valtype(data) == "A") .or. LEN(data) < REP_FIELDS
      return .F.
   endif
else
   data[REP_TITLE   ] := NIL
   data[REP_GRP_EXP ] := NIL
   data[REP_SUB_EXP ] := NIL
   data[REP_GRP_HEAD] := NIL
   data[REP_SUB_HEAD] := NIL
   data[REP_PG_WIDTH] := 80
   data[REP_PG_LINES] := 65
   data[REP_LEF_MARG] := 0
   data[REP_RGT_MARG] := 0
   data[REP_COLUMN_C] := 0
   data[REP_DBL_SPC ] := .F.
   data[REP_SUMMARY ] := .F.
   data[REP_EJECT   ] := .T.
   data[REP_EJECT_BF] := .F.
   data[REP_EJECT_AF] := .T.
   data[REP_PLAIN   ] := .F.
   data[REP_FIELDS  ] := {}
endif

if VALTYPE(data[REP_TITLE]) == "C"
   header := __splittxt (data[REP_TITLE], 4)   // FS library function
endif
if VALTYPE(data[REP_GRP_HEAD]) == "C"
   grphead := __splittxt (data[REP_GRP_HEAD], 4)
endif
if VALTYPE(data[REP_SUB_HEAD]) == "C"
   subhead := __splittxt (data[REP_SUB_HEAD], 4)
endif

for ii := 1 to MAX_FIELD_NO
   if VALTYPE(fields[ii]) != "A" .or. len(fields[ii]) != REP_FLD_TOTAL
      fields[ii] := ARRAY(REP_FLD_SIZE)
   endif
   fields[ii, REP_FLD_WIDTH] := 0
   fields[ii, REP_FLD_DECI ] := 0
   fields[ii, REP_FLD_HEAD ] := {"","","",""}
   fields[ii, REP_FLD_EXP  ] := ""
   fields[ii, REP_FLD_TOTAL] := .F.

   if ii <= data[REP_COLUMN_C]
      fields[ii, REP_FLD_WIDTH] := data[REP_FIELDS, ii, REP_FLD_WIDTH]
      fields[ii, REP_FLD_DECI ] := data[REP_FIELDS, ii, REP_FLD_DECI ]
      if empty(data[REP_FIELDS, ii, REP_FLD_HEAD])
         fields[ii, REP_FLD_HEAD ] := {"","","",""}
      else
         fields[ii, REP_FLD_HEAD]  := ;
             __splittxt (data[REP_FIELDS, ii, REP_FLD_HEAD], 4)
      endif
      fields[ii, REP_FLD_EXP  ] := data[REP_FIELDS, ii, REP_FLD_EXP  ]
      fields[ii, REP_FLD_TOTAL] := data[REP_FIELDS, ii, REP_FLD_TOTAL]
      field_type (fields[ii])
   endif
next

data[REP_GRP_EXP] := if( data[REP_GRP_EXP]==NIL, space(MAX_EXPR_STR), ;
                         PADR(data[REP_GRP_EXP],MAX_EXPR_STR))
data[REP_SUB_EXP] := if( data[REP_SUB_EXP]==NIL,space(MAX_EXPR_STR), ;
                         PADR(data[REP_SUB_EXP],MAX_EXPR_STR))

return .T.

* +-------------------------------------------------------------------------+
* | save report data using F10, with data checking                          |
* | Note: by xBASE specification, the fix defined structure of a .frm file  |
* |       allows maximum length of all strings (sum) up to 1440 bytes.      |
* +-------------------------------------------------------------------------+
STATIC FUNCTION RepoSave (p1, p2, p3)
LOCAL count_expr, ii, ok
data_to_save()                              // data[] to save[]
saved := .T.

data_to_save()                             // copy data[] to save[]

count_expr := if (empty(save[REP_TITLE   ]), 0, LEN(save[REP_TITLE   ])) +1
count_expr += if (empty(save[REP_GRP_EXP ]), 0, LEN(save[REP_GRP_EXP ])) +1
count_expr += if (empty(save[REP_GRP_HEAD]), 0, LEN(save[REP_GRP_HEAD])) +1
count_expr += if (empty(save[REP_SUB_EXP ]), 0, LEN(save[REP_SUB_EXP ])) +1
count_expr += if (empty(save[REP_SUB_HEAD]), 0, LEN(save[REP_SUB_HEAD])) +1

if LEN(save[REP_FIELDS]) = 0 .or. save[REP_COLUMN_C] = 0 .or. ;
   LEN(save[REP_FIELDS]) != save[REP_COLUMN_C]
   ALERT (text[52],, colors[8])
   saved := .F.
else
   FOR ii := 1 TO save[REP_COLUMN_C]
      if !empty(save[REP_FIELDS, ii, REP_FLD_EXP])
         count_expr += LEN(save[REP_FIELDS, ii, REP_FLD_EXP]) +1
      else
         ALERT (text[53] + ltrim(str(ii)) + ": " + text[51],,colors[8])
         saved := .F.
      endif
      count_expr += if (empty(save[REP_FIELDS, ii, REP_FLD_HEAD]), 0, ;
                          LEN(save[REP_FIELDS, ii, REP_FLD_HEAD])) +1
   NEXT
endif
if count_expr >= MAX_EXPR_STR                          // strings too long
   ALERT (text[48]+LTRIM(STR(MAX_EXPR_STR)) + ";" + ;
          text[49]+LTRIM(STR(count_expr)) + ";" + text[50],, colors[8])
   saved := .F.
endif
ii := displ_f7 (0, 99, , .T.) -5
if ii > data[REP_PG_WIDTH]
   ALERT (text[60]+LTRIM(STR(ii)),, colors[8])
   saved   := .F.
   nextwin := K_F2
endif
if saved
   ok := __reportsw (glfilename, save)               // FS library function
   if (valtype(ok) == "L" .and. ok   ) .or. ;        // FS4.3.2 and up
      (valtype(ok) $ "NFI" .and. ok==0)              // FS4.3.1 and below
      IF ALERT (text[61]+";"+glfilename+";"+text[45], {text[46],text[47]}, colors[8]) == 1
         nextwin := if (nextwin = 0, K_F2, nextwin)
      else
         nextwin = K_ESC
      ENDIF
   else
      ALERT (text[48]+LTRIM(STR(MAX_EXPR_STR)) + ";" + ;
             text[49]+LTRIM(STR(count_expr)) + ";" + text[50],, colors[8])
      saved := .F.
      nextwin = K_F2
   endif
   BREAK
endif
return NIL

* +-------------------------------------------------------------------------+
* | terminate REPORT EDIT                                                   |
* +-------------------------------------------------------------------------+
STATIC FUNCTION RepoEsc (p1, p2, p3)
if !saved
   IF ALERT (text[43], {text[39],text[44]}) == 1
      nextwin := if (nextwin == 0, K_F2, nextwin)
      return NIL
   ENDIF
else
   IF ALERT (text[45], {text[46],text[47]}, colors[8]) == 1
      nextwin := if (nextwin == 0, K_F2, nextwin)
       return NIL
   ENDIF
endif
nextwin = K_ESC
BREAK
return NIL

static function f2_help (p1, p2, p3)
*------------------------------------------------------------------------
static xtxt := {  ;
    "F2 window: Global page data, general page headings", ;
    "PAGE HEADER LINE 1..4" ,;
    "   Up to four heading lines (0..80 chars) are available."   , ;
    "   To leave a line empty, enter dot (.) at the line begin." , ;
    "PAGE WIDTH", ;
    "   Enter the available paper width (in chars) incl. margin" ,;
    "PAGE HIGH", ;
    "   Enter the available paper size (in lines)" ,;
    "MARGIN LEFT/RIGHT", ;
    "   Left and right margin (in chars) or zero", ;
    "DOUBLE SPACING", ;
    "   Enter T if double spacing is required, F otherwise", ;
    "PLAIN" ,;
    "   Enter T if no header output is required, F otherwise", ;
    "EJECT BEGIN", ;
    "   Enter T if page eject before the report starts ", ;
    "   is required, F otherwise", ;
    "EJECT END", ;
    "   Enter T if page eject after the printout is required" }

help_out (xtxt)
return NIL

static function f3_help (p1, p2, p3)
*------------------------------------------------------------------------
static xtxt1 := { ;
    "F3 window: Specification of the Report Columns", ;
    "COLUMN nn/nn", ;
    "   Displays the current/total report column", ;
    "", ;
    "Add/Replace/Delete/Ins", ;
    "   Specifies the process mode:", ;
    "   Add     [A] = append new report column", ;
    "   Replace [R] = replace the column data" , ;
    "   Delete  [D] = remove this column", ;
    "   Insert  [I] = insert new column before", ;
    "                 the current one" , ;
    "[PgUp/PgDn]: browse the report columns", ;
    "[F2], [F4], [F7] go to other window" , ;
    "[F10] save and exit" }
local  xtxt2 := { ;
    "F3 window: Specification of the Report Columns", ;
    "EXPRESSION", ;
    "   Enter the field/column expression, e.g. the dbf field" ,;
    "   name, or name+name etc. Validation: If a [?] is displayed ", ;
    "   in front of the expression, error was detected during the",;
    "   expression evaluation.", ;
    "   The total report expression length cannot", ;
    "   extend " + ltrim(str(MAX_EXPR_STR)) + " characters.", ;
    "[F5], [F6]: overtake specs from available databases." }
static xtxt3 := { ;
    "F3 window: Specification of the Report Columns", ;
    "HEADER 1..4",;
    "   Enter the optional heading of the column. Up to " ,;
    "   four lines are available. To leave a line empty," ,;
    "   enter dot (.) at the line begin." , ;
     "", ;
    "WIDTH", ;
    "   Enter the column wide (in chars). If the expression",;
    "   was generated by the [F5] key, the column WIDTH", ;
    "   corresponds to the field width.", ;
    "", ;
    "DECIMALS", ;
    "   For numeric data only, zero specifies integers", ;
    "", ;
    "TOTAL", ;
    "   Calculate TOTALs (True/False) for this column", ;
    "[Enter], [F10]: save and continue/exit" , ;
    "[PgUp/PgDn]: save current data, browse to next column" }

p3 := upper(strtran(p3, " "))
if p3 == "FIELD_ADD"
   help_out (xtxt1)
elseif "INFIELD" $ p3
   do case
   case "[4" $ p3            // expression
      help_out (xtxt2)
   otherwise
      help_out (xtxt3)
   endcase
endif
return NIL

static function f4_help (p1, p2, p3)
*------------------------------------------------------------------------
static xtxt := { ;
    "F4 window: Specification of Groups (optional)", ;
    "GROUP KEY EXPRESSION" , ;
    "   Enter the group expression, e.g. the dbf " ,;
    "   field name, or name+name etc.", ;
    "HEADER 1..4",;
    "   Enter the optional heading of the group. Up to " ,;
    "   four lines are available. To leave a line empty," ,;
    "   enter dot (.) at the line begin." , ;
    "SUMMARY" ,;
    "   T: Display only totals of groups/subgroup, ", ;
    "   F: Display detailed group/subgroup info. May be", ;
    "      overriden by the SUMMARY clause of REPORT FORM", ;
    "EJECT" ,;
    "   T: Eject new page on report begin. May be overriden", ;
    "      by the NOEJECT clause of REPORT FORM", ;
    "   F: Suppress the page eject on report begin", ;
    "GROUP KEY EXPRESSION" , ;
    "   Enter the subgroup expression, e.g. the dbf " ,;
    "   field name, or name+name etc.", ;
    "HEADER 1..4",;
    "   Enter the optional heading of the subgroup. " ,;
    "   Up to 4 lines, similar to group header" }
help_out (xtxt)
return NIL

static function help_out (aTxt, wind)
*------------------------------------------------------------------------
* aTxt[] : the text to display, 1st line = Header
* [wind] : window (2,3,4,5,7), default = current window

LOCAL_INT ii, r1, r2, c1, c2
LOCAL     wide := 0, len, rr
LOCAL     savscr, savcolor, msg := "Press any key"

wind := if (wind == NIL, window, wind)
len  := len(aTxt)                                  // array size
aeval (aTxt, {|x| wide := max(wide, len(x)) } )    // max text length

do case
case wind == 2                                     // bottom right
   r2 := maxrow() -2
   r1 := r2 - len
   c2 := maxcol() -2
   c1 := c2 - wide +1
case wind == 3                                     // bottom left
   r2 := maxrow() -2
   r1 := r2 - len
   c1 := 2
   c2 := c1 + wide -1
case wind == 4                                     // top right
   r1 := 2
   r2 := r1 + len
   c2 := maxcol() -2
   c1 := c2 - wide +1
case wind == 5                                     // top left
   r1 := 2
   r2 := r1 + len
   c1 := 2
   c2 := c1 + wide -1
otherwise
   r1 := int((maxrow() - len - 1) / 2)             // calculate lines
   r2 := r1 + len
   c1 := int((maxcol() - wide) / 2)                // calculate columns
   c2 := c1 + wide -1
endcase

savscr := savescreen (r1-1, c1-2, r2+1, c2+2)      // save screen
savcolor := setcolor(colors[5])                    // save & set colors

colorselect (1)
@ r1-1,c1-2 to       r2+1,c2+2                     // box, enhanced color
colorselect (0)
@ r1,  c1-1 clear to r2,  c2+1                     // std. help color

colorselect (4)
@ r1,c1 SAY aTxt[1]                                // display text array
colorselect (0)
rr := r1 +2
for ii := 2 to len
   @ rr++,c1 SAY aTxt[ii]                          // display text array
next

colorselect (1)
@ r2+1,c2-len(msg)+1 say msg                       // display msg,
colorselect (0)
inkey(0)                                           // wait for key

setcolor(savcolor)                                 // restore colors
restscreen (r1-1, c1-2, r2+1, c2+2, savscr)        // restore screen
return NIL

****************************************************************************
#ifndef FlagShip
   STATIC function STRPOKE (str, pos, char)        // in libFlagShip.a
   RETURN STUFF (str, pos, 1, chr(char))

   STATIC function STRPEEK (str, pos)              // in libFlagShip.a
   RETURN ASC (substr(str, pos, 1))

   static function __splittxt (text, lines)        // in libFlagShip.a
   local ltext := text, end := 0, ret := {}, ii := 1
   if !(valtype(lines) $ "NFI") ; lines := -1 ; endif
   if valtype(text) != "C"  ; return ret ; endif
   while ((end := at(";", ltext)) > 0) .and. (lines # 0)
      aadd(ret, substr(ltext, 1, end - 1))
      ltext := substr(ltext, min(len(ltext), end + 1))
      lines--
   enddo
   if lines # 0 ; aadd(ret, ltext) ; endif
   while --lines > 0 ; aadd(ret, "") ; enddo
   return ret

   static function __reportst ()                   // in libFlagShip.a
   return NIL

   static function __reportsw (glfilename, save)   // in libFlagShip.a
   return .T.
#endif     // FlagShip

#ifndef FIELDINFO_DEFINED
STATIC FUNCTION FIELDINFO (fname)                  // in next libFlagShip.a
LOCAL arr[0], dbfarr, ii

dbfarr := DBSTRUCT()
if len(dbfarr) > 3
   ii = AT ("->", fname)
   if ii > 0
      fname := ALLTRIM(SUBSTR (fname, ii+2))
   endif
   ii := ASCAN (dbfarr, {|x| x[1] == upper(fname) } )
   if ii > 0
      arr := ACLONE (dbfarr[ii])
   endif
endif
RETURN arr
#endif   // FIELDINFO_DEFINED

**  Layout **
**  0.........1.........2.........3.........4.........5.........6.........7.........8

* 1:xxxxxxxx.frm F2:page F3:column F4:group F5:fields F7:display F10:save ESC:quit
* 2:F2ĿF3: column nn/nnĿ
* 3:  Page header  line 1  : xxxxxxxxxxxxxxxxxxxxxxx Add/Replace/Delete/Ins:  x 
* 4:               line 2  : xxxxxxxxxxxxxxxxxxxxxxx ? Expr: xxxxxxxxxxxxxxxxxx 
* 5:               line 3  : xxxxxxxxxxxxxxxxxxxxxxx   Head: xxxxxxxxxxxxxxxxxx 
* 6:               line 4  : xxxxxxxxxxxxxxxxxxxxxxx     #2: xxxxxxxxxxxxxxxxxx 
* 7:  Page   wide/high     : xxx chars     xxx lines     #3: xxxxxxxxxxxxxxxxxx 
* 8:  Margin left/right    : xxx chars     xxx chars     #4: xxxxxxxxxxxxxxxxxx 
* 9:  Double spacing/plain :   F             F         Wide: xxx      Deci: xxx 
*10:  Eject  begin/end     :   T             F        Total: x                  
*11:
*12:F4ĿF5:xxxxxxxx.dbfĿ
*13:  Group key (express.) : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*14:        header text #1 : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*15:                    #2 : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*16:        Summary/Eject  : F  /  F                    xxxxxxxxxx C nnn nnn    
*17:  Subgroup key (expr.) : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*18:        header text #1 : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*19:F6:next dbf
*20:F7Ŀ
*21:....,....1....,....2....,....3....,....4....,....5....,....6....,....7....,...
*22:xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
*23:
*24: messages......

* 1:***----------------------25 and more lines----------------------------------
* 2:F2ĿF3:column nnĿ
* 3:  Page header  line 1  : xxxxxxxxxxxxxxxxxxxxxxx Add/Replace/Delete/Ins:  x 
* 4:               line 2  : xxxxxxxxxxxxxxxxxxxxxxx   Expr: xxxxxxxxxxxxxxxxxx 
* 5:               line 3  : xxxxxxxxxxxxxxxxxxxxxxx   Head: xxxxxxxxxxxxxxxxxx 
* 6:               line 4  : xxxxxxxxxxxxxxxxxxxxxxx     #2: xxxxxxxxxxxxxxxxxx 
* 7:  Page   wide/high     : xxx chars     xxx lines     #3: xxxxxxxxxxxxxxxxxx 
* 8:  Margin left/right    : xxx chars     xxx chars     #4: xxxxxxxxxxxxxxxxxx 
* 9:  Double spacing/plain :   F             F         Wide: xxx      Deci: xxx 
*10:  Eject  begin/end     :   T             F        Total: x                  
*11:
*12:F4ĿF5:xxxxxxxx.dbfĿ
*13:  Group key (express.) : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*14:        header text #1 : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*15:                    #2 : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*16:                    #3 : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*17:                    #4 : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*18:        Summary/Eject  : F  /  F                    xxxxxxxxxx C nnn nnn    
*19:  Subgroup key (expr.) : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*20:        header text #1 : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*21:        header text #2 : xxxxxxxxxxxxxxxxxxxxxxx    xxxxxxxxxx C nnn nnn    
*22:F6:next dbf
*23:F7Ŀ
*24:....,....1....,....2....,....3....,....4....,....5....,....6....,....7....,...
*25:xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
*26:xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
*   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
*37:xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
*38:xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
*39:
*42: messages......

*** eof repoedit.prg ***

