/****************************************************************************
 * SCOR_MEM.PRG enables access to the scoreboard messages in memoedit       *
 *                                                                          *
 * FlagShip     : compile with   FlagShip scor_mem.prg -m -na               *
 *--------------------------------------------------------------------------*
 * (c) 1998 multisoft Datentechnik GmbH, Germany.                           *
 ****************************************************************************/

#include "set.fh"
/* DEFINE MMSG_GERMAN */

// Scoreboard messages
// FlagShip: user defined messages taken from FSsortab.xxx,
//           if FS_SET("loadlang") and FS_SET("setlang") called.

// display coordinates for SCOREBOARD and Message for Escape

#define SCORE_ROW    0
#define SCORE_COL    60

#ifndef MMGS_GERMAN
#   define SCORE_ABORT  "Abort Edit (Y/N)?"
#else
#   define SCORE_ABORT  "Abbrechen  (J/N)?"
#endif
#define SCORE_ACLEAR "                 "

/*--------------------------------------------------------------------------*
 | Function MemoScoreEsc()      Serves to decide if ESC shall quit Memoedit |
 |                              Called after Escape is presses on a changed |
 |                              Text                                        |
 | In : -                                                                   |
 | Out: fn (L)  .T. : Memoedit will quit                                    |
 |              .F. : Memoedit will continue editing                        |
 *--------------------------------------------------------------------------*/
func MemoScoreEsc()
local nRow, nCol, Answer := .T.

   if ( Set(_SET_SCOREBOARD) )                        // SET SCOREBOARD ON ?
      nRow := Row()                                   // save actuall cursor
      nCol := Col()
      SetPos(SCORE_ROW, SCORE_COL)                    // see define
      DispOut(SCORE_ABORT)
#     ifndef MMGS_GERMAN
         Answer := chr(inkey(0)) $ "Yy"
#     else
         Answer := chr(inkey(0)) $ "JjYy"             // Clipper would expect Y
#     endif
      SetPos(SCORE_ROW, SCORE_COL)                    // overwrite with
      DispOut(SCORE_ACLEAR)                           // Blanks
      SetPos(nRow, nCol)                              // restore cursor
   end
return Answer

/*--------------------------------------------------------------------------*
 | Function MemoScoreIns()      Serves to display Insert State in Memoedit  |
 |                              Called after Insert is presses              |
 | In p1(L):  Insertstate  The state of Insert mode                         |
 *--------------------------------------------------------------------------*/
func MemoScoreIns(InsertState)

local nRow, nCol, cMsg:= _LANGNAMES (1)               // see also GetSys.prg

   if ( Set(_SET_SCOREBOARD) )                        // SET SCOREBOARD ON ?
      nRow := Row()                                   // save actuall cursor
      nCol := Col()
      SetPos(SCORE_ROW, SCORE_COL)                    // see define
      DispOut( if(InsertState, cMsg, SPACE(LEN(cMsg)) ))
      SetPos(nRow, nCol)                              // restore cursor
   end
return

/*** eof ***/

