***************************************************************************
* Compatibility Functions to support calls to :                           *
*    NOSNOW()                                                             *
*    SETBLINK()                                                           *
*    SETMODE()                                                            *
*                                                                         *
* These functions do no change anything but its parameters and return-    *
* vaules are fully compatible to Clipper 5.x                              *
*-------------------------------------------------------------------------*
* Copyright (c) 1998 by multisoft Datentechnik GmbH, Munich               *
***************************************************************************

***************************************************************************
* setblink([<logvar>] -> currentsetting                                   *
*                                                                         *
* The display of blinking characters as intensive background is not       *
* available on most Terminals. This function is available for             *
* compatibility to Clipper.                                               *
***************************************************************************
function setblink(logvar)
static blinkmode := .F.           && the flag exist and may be toggled
local oldmode := blinkmode
if (valtype(logvar) == 'L')
   blinkmode := logvar
endif
return oldmode

***************************************************************************
* setmode(<lines>,<cols>) --> ldone                                       *
*                                                                         *
* Switching to a different screenmode is not supported by most terminals. *
* This function remains unsupported currently                             *
***************************************************************************
function setmode(nlines, ncols)
return .F.          && Tell program that we did not switch

***************************************************************************
* nosnow(logvar) --> NIL                                                  *
*                                                                         *
* Compatibility function.                                                 *
* Snow on the Terminal cannot be changed by the application               *
***************************************************************************
function nosnow(logvar)
return NIL
